// $ANTLR 2.7.1: "java.g" -> "GeneratedJavaRecognizer.java"$

package com.puppycrawl.tools.checkstyle;

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

/** Java 1.2 Recognizer
 *
 * Based heavily on the Grammer example that comes with ANTLR. See
 * http://www.antlr.org.
 *
 * BUG:
 * 		Doesn't like boolean.class!
 *
 * class Test {
 *   public static void main( String args[] ) {
 *     if (boolean.class.equals(boolean.class)) {
 *       System.out.println("works");
 *     }
 *   }
 * }
 */
public class GeneratedJavaRecognizer extends antlr.LLkParser
       implements GeneratedJavaTokenTypes
 {

    final Verifier ver = VerifierSingleton.getInstance();
    private static String sFirstIdent = "";
    private static final MyCommonAST[] sIgnoreAST = new MyCommonAST[2];
    private static LineText sLastIdentifier;
    private static final int[] sIgnoreType = new int[1];

    // Constants to indicate statement type. Numbers are delibrately weird
    private static int STMT_OTHER = 0;
    private static int STMT_COMPOUND = 6;
    private static int STMT_IF = 8;

protected GeneratedJavaRecognizer(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
}

public GeneratedJavaRecognizer(TokenBuffer tokenBuf) {
  this(tokenBuf,2);
}

protected GeneratedJavaRecognizer(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
}

public GeneratedJavaRecognizer(TokenStream lexer) {
  this(lexer,2);
}

public GeneratedJavaRecognizer(ParserSharedInputState state) {
  super(state,2);
  tokenNames = _tokenNames;
}

	public final void compilationUnit() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST compilationUnit_AST = null;
		
		{
		switch ( LA(1)) {
		case LITERAL_package:
		{
			packageDefinition();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			break;
		}
		case EOF:
		case FINAL:
		case ABSTRACT:
		case STRICTFP:
		case SEMI:
		case LITERAL_import:
		case LITERAL_private:
		case LITERAL_public:
		case LITERAL_protected:
		case LITERAL_static:
		case LITERAL_transient:
		case LITERAL_native:
		case LITERAL_threadsafe:
		case LITERAL_synchronized:
		case LITERAL_volatile:
		case LITERAL_class:
		case LITERAL_interface:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		{
		_loop4:
		do {
			if ((LA(1)==LITERAL_import)) {
				importDefinition();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				break _loop4;
			}
			
		} while (true);
		}
		{
		_loop6:
		do {
			if ((_tokenSet_0.member(LA(1)))) {
				typeDefinition();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				break _loop6;
			}
			
		} while (true);
		}
		MyCommonAST tmp1_AST = null;
		tmp1_AST = (MyCommonAST)astFactory.create(LT(1));
		match(Token.EOF_TYPE);
		compilationUnit_AST = (MyCommonAST)currentAST.root;
		returnAST = compilationUnit_AST;
	}
	
	public final void packageDefinition() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST packageDefinition_AST = null;
		Token  p = null;
		MyCommonAST p_AST = null;
		
		try {      // for error handling
			p = LT(1);
			if (inputState.guessing==0) {
				p_AST = (MyCommonAST)astFactory.create(p);
				astFactory.makeASTRoot(currentAST, p_AST);
			}
			match(LITERAL_package);
			if ( inputState.guessing==0 ) {
				p_AST.setType(PACKAGE_DEF);
			}
			identifier();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			MyCommonAST tmp2_AST = null;
			tmp2_AST = (MyCommonAST)astFactory.create(LT(1));
			match(SEMI);
			if ( inputState.guessing==0 ) {
				ver.reportPackageName(sLastIdentifier.getText());
			}
			packageDefinition_AST = (MyCommonAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		returnAST = packageDefinition_AST;
	}
	
	public final void importDefinition() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST importDefinition_AST = null;
		Token  i = null;
		MyCommonAST i_AST = null;
		
		try {      // for error handling
			i = LT(1);
			if (inputState.guessing==0) {
				i_AST = (MyCommonAST)astFactory.create(i);
				astFactory.makeASTRoot(currentAST, i_AST);
			}
			match(LITERAL_import);
			if ( inputState.guessing==0 ) {
				i_AST.setType(IMPORT);
			}
			identifierStar();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			MyCommonAST tmp3_AST = null;
			tmp3_AST = (MyCommonAST)astFactory.create(LT(1));
			match(SEMI);
			importDefinition_AST = (MyCommonAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		returnAST = importDefinition_AST;
	}
	
	public final void typeDefinition() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST typeDefinition_AST = null;
		MyCommonAST m_AST = null;
		MyModifierSet modSet = new MyModifierSet();
		
		try {      // for error handling
			switch ( LA(1)) {
			case FINAL:
			case ABSTRACT:
			case STRICTFP:
			case LITERAL_private:
			case LITERAL_public:
			case LITERAL_protected:
			case LITERAL_static:
			case LITERAL_transient:
			case LITERAL_native:
			case LITERAL_threadsafe:
			case LITERAL_synchronized:
			case LITERAL_volatile:
			case LITERAL_class:
			case LITERAL_interface:
			{
				modifiers(modSet);
				if (inputState.guessing==0) {
					m_AST = (MyCommonAST)returnAST;
				}
				{
				switch ( LA(1)) {
				case LITERAL_class:
				{
					classDefinition(m_AST, modSet);
					if (inputState.guessing==0) {
						astFactory.addASTChild(currentAST, returnAST);
					}
					break;
				}
				case LITERAL_interface:
				{
					interfaceDefinition(m_AST, modSet);
					if (inputState.guessing==0) {
						astFactory.addASTChild(currentAST, returnAST);
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				typeDefinition_AST = (MyCommonAST)currentAST.root;
				break;
			}
			case SEMI:
			{
				MyCommonAST tmp4_AST = null;
				tmp4_AST = (MyCommonAST)astFactory.create(LT(1));
				match(SEMI);
				typeDefinition_AST = (MyCommonAST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_2);
			} else {
			  throw ex;
			}
		}
		returnAST = typeDefinition_AST;
	}
	
	public final void identifier() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST identifier_AST = null;
		Token  i1 = null;
		MyCommonAST i1_AST = null;
		Token  i2 = null;
		MyCommonAST i2_AST = null;
		
		i1 = LT(1);
		if (inputState.guessing==0) {
			i1_AST = (MyCommonAST)astFactory.create(i1);
			astFactory.addASTChild(currentAST, i1_AST);
		}
		match(IDENT);
		if ( inputState.guessing==0 ) {
			
			ver.reportReference(i1.getText());
			sLastIdentifier = new LineText(i1.getLine(), i1.getColumn(), i1.getText());
			
		}
		{
		_loop23:
		do {
			if ((LA(1)==DOT)) {
				MyCommonAST tmp5_AST = null;
				if (inputState.guessing==0) {
					tmp5_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp5_AST);
				}
				match(DOT);
				i2 = LT(1);
				if (inputState.guessing==0) {
					i2_AST = (MyCommonAST)astFactory.create(i2);
					astFactory.addASTChild(currentAST, i2_AST);
				}
				match(IDENT);
				if ( inputState.guessing==0 ) {
					ver.verifyDot(tmp5_AST); sLastIdentifier.appendText("." + i2.getText());
				}
			}
			else {
				break _loop23;
			}
			
		} while (true);
		}
		identifier_AST = (MyCommonAST)currentAST.root;
		returnAST = identifier_AST;
	}
	
	public final void identifierStar() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST identifierStar_AST = null;
		Token  i1 = null;
		MyCommonAST i1_AST = null;
		Token  i2 = null;
		MyCommonAST i2_AST = null;
		Token  i3 = null;
		MyCommonAST i3_AST = null;
		int ln = 0; String str = ""; boolean star = false;
		
		i1 = LT(1);
		if (inputState.guessing==0) {
			i1_AST = (MyCommonAST)astFactory.create(i1);
			astFactory.addASTChild(currentAST, i1_AST);
		}
		match(IDENT);
		if ( inputState.guessing==0 ) {
			ln = i1.getLine(); str = i1.getText();
		}
		{
		_loop26:
		do {
			if ((LA(1)==DOT) && (LA(2)==IDENT)) {
				MyCommonAST tmp6_AST = null;
				if (inputState.guessing==0) {
					tmp6_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp6_AST);
				}
				match(DOT);
				i2 = LT(1);
				if (inputState.guessing==0) {
					i2_AST = (MyCommonAST)astFactory.create(i2);
					astFactory.addASTChild(currentAST, i2_AST);
				}
				match(IDENT);
				if ( inputState.guessing==0 ) {
					str += "." + i2.getText(); ver.verifyDot(tmp6_AST);
				}
			}
			else {
				break _loop26;
			}
			
		} while (true);
		}
		{
		switch ( LA(1)) {
		case DOT:
		{
			MyCommonAST tmp7_AST = null;
			if (inputState.guessing==0) {
				tmp7_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp7_AST);
			}
			match(DOT);
			i3 = LT(1);
			if (inputState.guessing==0) {
				i3_AST = (MyCommonAST)astFactory.create(i3);
				astFactory.addASTChild(currentAST, i3_AST);
			}
			match(STAR);
			if ( inputState.guessing==0 ) {
				str += ".*"; star = true; ver.verifyDot(tmp7_AST);
			}
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			
			if (star) {
			ver.reportStarImport(ln, str);
			} else {
			ver.reportImport(ln, str);
			}
			
		}
		identifierStar_AST = (MyCommonAST)currentAST.root;
		returnAST = identifierStar_AST;
	}
	
	public final void modifiers(
		MyModifierSet mms
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST modifiers_AST = null;
		MyCommonAST m_AST = null;
		
		{
		_loop30:
		do {
			if ((_tokenSet_3.member(LA(1)))) {
				modifier();
				if (inputState.guessing==0) {
					m_AST = (MyCommonAST)returnAST;
					astFactory.addASTChild(currentAST, returnAST);
				}
				if ( inputState.guessing==0 ) {
					mms.addModifier(m_AST);
				}
			}
			else {
				break _loop30;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			modifiers_AST = (MyCommonAST)currentAST.root;
			modifiers_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(MODIFIERS,"MODIFIERS")).add(modifiers_AST));
			currentAST.root = modifiers_AST;
			currentAST.child = modifiers_AST!=null &&modifiers_AST.getFirstChild()!=null ?
				modifiers_AST.getFirstChild() : modifiers_AST;
			currentAST.advanceChildToEnd();
		}
		modifiers_AST = (MyCommonAST)currentAST.root;
		returnAST = modifiers_AST;
	}
	
	public final void classDefinition(
		MyCommonAST modifiers, MyModifierSet modSet
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST classDefinition_AST = null;
		Token  cc = null;
		MyCommonAST cc_AST = null;
		MyCommonAST sc_AST = null;
		MyCommonAST ic_AST = null;
		MyCommonAST cb_AST = null;
		
		cc = LT(1);
		if (inputState.guessing==0) {
			cc_AST = (MyCommonAST)astFactory.create(cc);
		}
		match(LITERAL_class);
		MyCommonAST tmp8_AST = null;
		if (inputState.guessing==0) {
			tmp8_AST = (MyCommonAST)astFactory.create(LT(1));
		}
		match(IDENT);
		superClassClause();
		if (inputState.guessing==0) {
			sc_AST = (MyCommonAST)returnAST;
		}
		implementsClause();
		if (inputState.guessing==0) {
			ic_AST = (MyCommonAST)returnAST;
		}
		if ( inputState.guessing==0 ) {
			
			ver.verifyType(modSet, tmp8_AST);
			ver.reportStartTypeBlock(modSet.getVisibilityScope(), false);
			
		}
		classBlock((modSet.size() == 0) ? cc_AST.getLineNo() : modSet.getFirstLineNo());
		if (inputState.guessing==0) {
			cb_AST = (MyCommonAST)returnAST;
		}
		if ( inputState.guessing==0 ) {
			classDefinition_AST = (MyCommonAST)currentAST.root;
			classDefinition_AST = (MyCommonAST)astFactory.make( (new ASTArray(6)).add((MyCommonAST)astFactory.create(CLASS_DEF,"CLASS_DEF")).add(modifiers).add(tmp8_AST).add(sc_AST).add(ic_AST).add(cb_AST));
			currentAST.root = classDefinition_AST;
			currentAST.child = classDefinition_AST!=null &&classDefinition_AST.getFirstChild()!=null ?
				classDefinition_AST.getFirstChild() : classDefinition_AST;
			currentAST.advanceChildToEnd();
		}
		if ( inputState.guessing==0 ) {
			
			ver.reportEndTypeBlock();
			
		}
		returnAST = classDefinition_AST;
	}
	
	public final void interfaceDefinition(
		MyCommonAST modifiers, MyModifierSet modSet
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST interfaceDefinition_AST = null;
		Token  ii = null;
		MyCommonAST ii_AST = null;
		MyCommonAST ie_AST = null;
		MyCommonAST cb_AST = null;
		
		ii = LT(1);
		if (inputState.guessing==0) {
			ii_AST = (MyCommonAST)astFactory.create(ii);
		}
		match(LITERAL_interface);
		MyCommonAST tmp9_AST = null;
		if (inputState.guessing==0) {
			tmp9_AST = (MyCommonAST)astFactory.create(LT(1));
		}
		match(IDENT);
		interfaceExtends();
		if (inputState.guessing==0) {
			ie_AST = (MyCommonAST)returnAST;
		}
		if ( inputState.guessing==0 ) {
			
			ver.verifyType(modSet, tmp9_AST);
			ver.reportStartTypeBlock(modSet.getVisibilityScope(), true);
			
		}
		classBlock((modSet.size() == 0) ? ii_AST.getLineNo() : modSet.getFirstLineNo());
		if (inputState.guessing==0) {
			cb_AST = (MyCommonAST)returnAST;
		}
		if ( inputState.guessing==0 ) {
			interfaceDefinition_AST = (MyCommonAST)currentAST.root;
			interfaceDefinition_AST = (MyCommonAST)astFactory.make( (new ASTArray(5)).add((MyCommonAST)astFactory.create(INTERFACE_DEF,"INTERFACE_DEF")).add(modifiers).add(tmp9_AST).add(ie_AST).add(cb_AST));
			currentAST.root = interfaceDefinition_AST;
			currentAST.child = interfaceDefinition_AST!=null &&interfaceDefinition_AST.getFirstChild()!=null ?
				interfaceDefinition_AST.getFirstChild() : interfaceDefinition_AST;
			currentAST.advanceChildToEnd();
		}
		if ( inputState.guessing==0 ) {
			
			ver.reportEndTypeBlock();
			
		}
		returnAST = interfaceDefinition_AST;
	}
	
/** A declaration is the creation of a reference or primitive-type variable
 *  Create a separate Type/Var tree for each var in the var list.
 */
	public final void declaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST declaration_AST = null;
		MyCommonAST m_AST = null;
		MyCommonAST t_AST = null;
		MyCommonAST v_AST = null;
		MyModifierSet modSet = new MyModifierSet();
		
		modifiers(modSet);
		if (inputState.guessing==0) {
			m_AST = (MyCommonAST)returnAST;
		}
		typeSpec(false);
		if (inputState.guessing==0) {
			t_AST = (MyCommonAST)returnAST;
		}
		variableDefinitions(m_AST,t_AST, modSet);
		if (inputState.guessing==0) {
			v_AST = (MyCommonAST)returnAST;
		}
		if ( inputState.guessing==0 ) {
			declaration_AST = (MyCommonAST)currentAST.root;
			declaration_AST = v_AST;
			currentAST.root = declaration_AST;
			currentAST.child = declaration_AST!=null &&declaration_AST.getFirstChild()!=null ?
				declaration_AST.getFirstChild() : declaration_AST;
			currentAST.advanceChildToEnd();
		}
		returnAST = declaration_AST;
	}
	
	public final void typeSpec(
		boolean addImagNode
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST typeSpec_AST = null;
		
		switch ( LA(1)) {
		case IDENT:
		{
			classTypeSpec(addImagNode);
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			typeSpec_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_void:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_short:
		case LITERAL_int:
		case LITERAL_float:
		case LITERAL_long:
		case LITERAL_double:
		{
			builtInTypeSpec(addImagNode);
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			typeSpec_AST = (MyCommonAST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = typeSpec_AST;
	}
	
	public final void variableDefinitions(
		MyCommonAST mods, MyCommonAST t, MyModifierSet modSet
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST variableDefinitions_AST = null;
		
		variableDeclarator((MyCommonAST) getASTFactory().dupTree(mods),
						   (MyCommonAST) getASTFactory().dupTree(t),
                           modSet);
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		_loop62:
		do {
			if ((LA(1)==COMMA)) {
				MyCommonAST tmp10_AST = null;
				tmp10_AST = (MyCommonAST)astFactory.create(LT(1));
				match(COMMA);
				variableDeclarator((MyCommonAST) getASTFactory().dupTree(mods),
							   (MyCommonAST) getASTFactory().dupTree(t),
                               modSet);
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				break _loop62;
			}
			
		} while (true);
		}
		variableDefinitions_AST = (MyCommonAST)currentAST.root;
		returnAST = variableDefinitions_AST;
	}
	
	public final void classTypeSpec(
		boolean addImagNode
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST classTypeSpec_AST = null;
		Token  lb = null;
		MyCommonAST lb_AST = null;
		
		identifier();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		_loop15:
		do {
			if ((LA(1)==LBRACK)) {
				lb = LT(1);
				if (inputState.guessing==0) {
					lb_AST = (MyCommonAST)astFactory.create(lb);
					astFactory.makeASTRoot(currentAST, lb_AST);
				}
				match(LBRACK);
				if ( inputState.guessing==0 ) {
					lb_AST.setType(ARRAY_DECLARATOR);
				}
				MyCommonAST tmp11_AST = null;
				tmp11_AST = (MyCommonAST)astFactory.create(LT(1));
				match(RBRACK);
			}
			else {
				break _loop15;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			classTypeSpec_AST = (MyCommonAST)currentAST.root;
			
						if ( addImagNode ) {
							classTypeSpec_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(TYPE,"TYPE")).add(classTypeSpec_AST));
						}
					
			currentAST.root = classTypeSpec_AST;
			currentAST.child = classTypeSpec_AST!=null &&classTypeSpec_AST.getFirstChild()!=null ?
				classTypeSpec_AST.getFirstChild() : classTypeSpec_AST;
			currentAST.advanceChildToEnd();
		}
		classTypeSpec_AST = (MyCommonAST)currentAST.root;
		returnAST = classTypeSpec_AST;
	}
	
	public final void builtInTypeSpec(
		boolean addImagNode
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST builtInTypeSpec_AST = null;
		Token  lb = null;
		MyCommonAST lb_AST = null;
		
		builtInType();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		_loop18:
		do {
			if ((LA(1)==LBRACK)) {
				lb = LT(1);
				if (inputState.guessing==0) {
					lb_AST = (MyCommonAST)astFactory.create(lb);
					astFactory.makeASTRoot(currentAST, lb_AST);
				}
				match(LBRACK);
				if ( inputState.guessing==0 ) {
					lb_AST.setType(ARRAY_DECLARATOR);
				}
				MyCommonAST tmp12_AST = null;
				tmp12_AST = (MyCommonAST)astFactory.create(LT(1));
				match(RBRACK);
			}
			else {
				break _loop18;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			builtInTypeSpec_AST = (MyCommonAST)currentAST.root;
			
						if ( addImagNode ) {
							builtInTypeSpec_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(TYPE,"TYPE")).add(builtInTypeSpec_AST));
						}
					
			currentAST.root = builtInTypeSpec_AST;
			currentAST.child = builtInTypeSpec_AST!=null &&builtInTypeSpec_AST.getFirstChild()!=null ?
				builtInTypeSpec_AST.getFirstChild() : builtInTypeSpec_AST;
			currentAST.advanceChildToEnd();
		}
		builtInTypeSpec_AST = (MyCommonAST)currentAST.root;
		returnAST = builtInTypeSpec_AST;
	}
	
	public final void builtInType() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST builtInType_AST = null;
		
		switch ( LA(1)) {
		case LITERAL_void:
		{
			MyCommonAST tmp13_AST = null;
			if (inputState.guessing==0) {
				tmp13_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp13_AST);
			}
			match(LITERAL_void);
			builtInType_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_boolean:
		{
			MyCommonAST tmp14_AST = null;
			if (inputState.guessing==0) {
				tmp14_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp14_AST);
			}
			match(LITERAL_boolean);
			builtInType_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_byte:
		{
			MyCommonAST tmp15_AST = null;
			if (inputState.guessing==0) {
				tmp15_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp15_AST);
			}
			match(LITERAL_byte);
			builtInType_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_char:
		{
			MyCommonAST tmp16_AST = null;
			if (inputState.guessing==0) {
				tmp16_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp16_AST);
			}
			match(LITERAL_char);
			builtInType_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_short:
		{
			MyCommonAST tmp17_AST = null;
			if (inputState.guessing==0) {
				tmp17_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp17_AST);
			}
			match(LITERAL_short);
			builtInType_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_int:
		{
			MyCommonAST tmp18_AST = null;
			if (inputState.guessing==0) {
				tmp18_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp18_AST);
			}
			match(LITERAL_int);
			builtInType_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_float:
		{
			MyCommonAST tmp19_AST = null;
			if (inputState.guessing==0) {
				tmp19_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp19_AST);
			}
			match(LITERAL_float);
			builtInType_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_long:
		{
			MyCommonAST tmp20_AST = null;
			if (inputState.guessing==0) {
				tmp20_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp20_AST);
			}
			match(LITERAL_long);
			builtInType_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_double:
		{
			MyCommonAST tmp21_AST = null;
			if (inputState.guessing==0) {
				tmp21_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp21_AST);
			}
			match(LITERAL_double);
			builtInType_AST = (MyCommonAST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = builtInType_AST;
	}
	
	public final void type() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST type_AST = null;
		
		switch ( LA(1)) {
		case IDENT:
		{
			identifier();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			type_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_void:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_short:
		case LITERAL_int:
		case LITERAL_float:
		case LITERAL_long:
		case LITERAL_double:
		{
			builtInType();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			type_AST = (MyCommonAST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = type_AST;
	}
	
	public final void modifier() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST modifier_AST = null;
		
		switch ( LA(1)) {
		case LITERAL_private:
		{
			MyCommonAST tmp22_AST = null;
			if (inputState.guessing==0) {
				tmp22_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp22_AST);
			}
			match(LITERAL_private);
			modifier_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_public:
		{
			MyCommonAST tmp23_AST = null;
			if (inputState.guessing==0) {
				tmp23_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp23_AST);
			}
			match(LITERAL_public);
			modifier_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_protected:
		{
			MyCommonAST tmp24_AST = null;
			if (inputState.guessing==0) {
				tmp24_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp24_AST);
			}
			match(LITERAL_protected);
			modifier_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_static:
		{
			MyCommonAST tmp25_AST = null;
			if (inputState.guessing==0) {
				tmp25_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp25_AST);
			}
			match(LITERAL_static);
			modifier_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_transient:
		{
			MyCommonAST tmp26_AST = null;
			if (inputState.guessing==0) {
				tmp26_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp26_AST);
			}
			match(LITERAL_transient);
			modifier_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case FINAL:
		{
			MyCommonAST tmp27_AST = null;
			if (inputState.guessing==0) {
				tmp27_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp27_AST);
			}
			match(FINAL);
			modifier_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case ABSTRACT:
		{
			MyCommonAST tmp28_AST = null;
			if (inputState.guessing==0) {
				tmp28_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp28_AST);
			}
			match(ABSTRACT);
			modifier_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_native:
		{
			MyCommonAST tmp29_AST = null;
			if (inputState.guessing==0) {
				tmp29_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp29_AST);
			}
			match(LITERAL_native);
			modifier_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_threadsafe:
		{
			MyCommonAST tmp30_AST = null;
			if (inputState.guessing==0) {
				tmp30_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp30_AST);
			}
			match(LITERAL_threadsafe);
			modifier_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_synchronized:
		{
			MyCommonAST tmp31_AST = null;
			if (inputState.guessing==0) {
				tmp31_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp31_AST);
			}
			match(LITERAL_synchronized);
			modifier_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_volatile:
		{
			MyCommonAST tmp32_AST = null;
			if (inputState.guessing==0) {
				tmp32_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp32_AST);
			}
			match(LITERAL_volatile);
			modifier_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case STRICTFP:
		{
			MyCommonAST tmp33_AST = null;
			if (inputState.guessing==0) {
				tmp33_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp33_AST);
			}
			match(STRICTFP);
			modifier_AST = (MyCommonAST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = modifier_AST;
	}
	
	public final void superClassClause() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST superClassClause_AST = null;
		MyCommonAST id_AST = null;
		
		{
		switch ( LA(1)) {
		case LITERAL_extends:
		{
			MyCommonAST tmp34_AST = null;
			if (inputState.guessing==0) {
				tmp34_AST = (MyCommonAST)astFactory.create(LT(1));
			}
			match(LITERAL_extends);
			identifier();
			if (inputState.guessing==0) {
				id_AST = (MyCommonAST)returnAST;
			}
			break;
		}
		case LCURLY:
		case LITERAL_implements:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			superClassClause_AST = (MyCommonAST)currentAST.root;
			superClassClause_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(EXTENDS_CLAUSE,"EXTENDS_CLAUSE")).add(id_AST));
			currentAST.root = superClassClause_AST;
			currentAST.child = superClassClause_AST!=null &&superClassClause_AST.getFirstChild()!=null ?
				superClassClause_AST.getFirstChild() : superClassClause_AST;
			currentAST.advanceChildToEnd();
		}
		returnAST = superClassClause_AST;
	}
	
	public final void implementsClause() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST implementsClause_AST = null;
		Token  i = null;
		MyCommonAST i_AST = null;
		
		{
		switch ( LA(1)) {
		case LITERAL_implements:
		{
			i = LT(1);
			if (inputState.guessing==0) {
				i_AST = (MyCommonAST)astFactory.create(i);
			}
			match(LITERAL_implements);
			identifier();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			{
			_loop46:
			do {
				if ((LA(1)==COMMA)) {
					MyCommonAST tmp35_AST = null;
					tmp35_AST = (MyCommonAST)astFactory.create(LT(1));
					match(COMMA);
					identifier();
					if (inputState.guessing==0) {
						astFactory.addASTChild(currentAST, returnAST);
					}
				}
				else {
					break _loop46;
				}
				
			} while (true);
			}
			break;
		}
		case LCURLY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			implementsClause_AST = (MyCommonAST)currentAST.root;
			implementsClause_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(IMPLEMENTS_CLAUSE,"IMPLEMENTS_CLAUSE")).add(implementsClause_AST));
			currentAST.root = implementsClause_AST;
			currentAST.child = implementsClause_AST!=null &&implementsClause_AST.getFirstChild()!=null ?
				implementsClause_AST.getFirstChild() : implementsClause_AST;
			currentAST.advanceChildToEnd();
		}
		implementsClause_AST = (MyCommonAST)currentAST.root;
		returnAST = implementsClause_AST;
	}
	
	public final void classBlock(
		int aLine
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST classBlock_AST = null;
		Token  lc = null;
		MyCommonAST lc_AST = null;
		
		lc = LT(1);
		if (inputState.guessing==0) {
			lc_AST = (MyCommonAST)astFactory.create(lc);
		}
		match(LCURLY);
		if ( inputState.guessing==0 ) {
			if (aLine != -1) ver.verifyLCurlyType(aLine, lc_AST);
		}
		{
		_loop38:
		do {
			switch ( LA(1)) {
			case FINAL:
			case ABSTRACT:
			case STRICTFP:
			case LITERAL_void:
			case LITERAL_boolean:
			case LITERAL_byte:
			case LITERAL_char:
			case LITERAL_short:
			case LITERAL_int:
			case LITERAL_float:
			case LITERAL_long:
			case LITERAL_double:
			case IDENT:
			case LITERAL_private:
			case LITERAL_public:
			case LITERAL_protected:
			case LITERAL_static:
			case LITERAL_transient:
			case LITERAL_native:
			case LITERAL_threadsafe:
			case LITERAL_synchronized:
			case LITERAL_volatile:
			case LITERAL_class:
			case LITERAL_interface:
			case LCURLY:
			{
				field();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
				break;
			}
			case SEMI:
			{
				MyCommonAST tmp36_AST = null;
				tmp36_AST = (MyCommonAST)astFactory.create(LT(1));
				match(SEMI);
				break;
			}
			default:
			{
				break _loop38;
			}
			}
		} while (true);
		}
		MyCommonAST tmp37_AST = null;
		tmp37_AST = (MyCommonAST)astFactory.create(LT(1));
		match(RCURLY);
		if ( inputState.guessing==0 ) {
			classBlock_AST = (MyCommonAST)currentAST.root;
			classBlock_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(OBJBLOCK,"OBJBLOCK")).add(classBlock_AST));
			currentAST.root = classBlock_AST;
			currentAST.child = classBlock_AST!=null &&classBlock_AST.getFirstChild()!=null ?
				classBlock_AST.getFirstChild() : classBlock_AST;
			currentAST.advanceChildToEnd();
		}
		classBlock_AST = (MyCommonAST)currentAST.root;
		returnAST = classBlock_AST;
	}
	
	public final void interfaceExtends() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST interfaceExtends_AST = null;
		Token  e = null;
		MyCommonAST e_AST = null;
		
		{
		switch ( LA(1)) {
		case LITERAL_extends:
		{
			e = LT(1);
			if (inputState.guessing==0) {
				e_AST = (MyCommonAST)astFactory.create(e);
			}
			match(LITERAL_extends);
			identifier();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			{
			_loop42:
			do {
				if ((LA(1)==COMMA)) {
					MyCommonAST tmp38_AST = null;
					tmp38_AST = (MyCommonAST)astFactory.create(LT(1));
					match(COMMA);
					identifier();
					if (inputState.guessing==0) {
						astFactory.addASTChild(currentAST, returnAST);
					}
				}
				else {
					break _loop42;
				}
				
			} while (true);
			}
			break;
		}
		case LCURLY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			interfaceExtends_AST = (MyCommonAST)currentAST.root;
			interfaceExtends_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(EXTENDS_CLAUSE,"EXTENDS_CLAUSE")).add(interfaceExtends_AST));
			currentAST.root = interfaceExtends_AST;
			currentAST.child = interfaceExtends_AST!=null &&interfaceExtends_AST.getFirstChild()!=null ?
				interfaceExtends_AST.getFirstChild() : interfaceExtends_AST;
			currentAST.advanceChildToEnd();
		}
		interfaceExtends_AST = (MyCommonAST)currentAST.root;
		returnAST = interfaceExtends_AST;
	}
	
	public final void field() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST field_AST = null;
		MyCommonAST mods_AST = null;
		MyCommonAST h_AST = null;
		MyCommonAST s_AST = null;
		MyCommonAST cd_AST = null;
		MyCommonAST id_AST = null;
		MyCommonAST t_AST = null;
		MyCommonAST param_AST = null;
		MyCommonAST rt_AST = null;
		MyCommonAST tc_AST = null;
		MyCommonAST s2_AST = null;
		MyCommonAST v_AST = null;
		Token  st = null;
		MyCommonAST st_AST = null;
		MyCommonAST s3_AST = null;
		MyCommonAST s4_AST = null;
		
		java.util.List exs = new java.util.ArrayList();
		MethodSignature msig = new MethodSignature();
		final MyCommonAST[] stmtBraces = new MyCommonAST[2];
		
		
		if ((_tokenSet_4.member(LA(1))) && (_tokenSet_5.member(LA(2)))) {
			modifiers(msig.getModSet());
			if (inputState.guessing==0) {
				mods_AST = (MyCommonAST)returnAST;
			}
			{
			switch ( LA(1)) {
			case LITERAL_class:
			{
				classDefinition(mods_AST, msig.getModSet());
				if (inputState.guessing==0) {
					cd_AST = (MyCommonAST)returnAST;
				}
				if ( inputState.guessing==0 ) {
					field_AST = (MyCommonAST)currentAST.root;
					field_AST = cd_AST;
					currentAST.root = field_AST;
					currentAST.child = field_AST!=null &&field_AST.getFirstChild()!=null ?
						field_AST.getFirstChild() : field_AST;
					currentAST.advanceChildToEnd();
				}
				break;
			}
			case LITERAL_interface:
			{
				interfaceDefinition(mods_AST, msig.getModSet());
				if (inputState.guessing==0) {
					id_AST = (MyCommonAST)returnAST;
				}
				if ( inputState.guessing==0 ) {
					field_AST = (MyCommonAST)currentAST.root;
					field_AST = id_AST;
					currentAST.root = field_AST;
					currentAST.child = field_AST!=null &&field_AST.getFirstChild()!=null ?
						field_AST.getFirstChild() : field_AST;
					currentAST.advanceChildToEnd();
				}
				break;
			}
			default:
				if ((LA(1)==IDENT) && (LA(2)==LPAREN)) {
					ctorHead(exs, msig);
					if (inputState.guessing==0) {
						h_AST = (MyCommonAST)returnAST;
					}
					if ( inputState.guessing==0 ) {
						
						msig.setThrows(exs);
						ver.verifyMethod(msig);
						ver.reportStartMethodBlock();
						
					}
					constructorBody(msig.getFirstLineNo());
					if (inputState.guessing==0) {
						s_AST = (MyCommonAST)returnAST;
					}
					if ( inputState.guessing==0 ) {
						field_AST = (MyCommonAST)currentAST.root;
						field_AST = (MyCommonAST)astFactory.make( (new ASTArray(4)).add((MyCommonAST)astFactory.create(CTOR_DEF,"CTOR_DEF")).add(mods_AST).add(h_AST).add(s_AST));
						currentAST.root = field_AST;
						currentAST.child = field_AST!=null &&field_AST.getFirstChild()!=null ?
							field_AST.getFirstChild() : field_AST;
						currentAST.advanceChildToEnd();
					}
					if ( inputState.guessing==0 ) {
						ver.reportEndMethodBlock();
					}
				}
				else if (((LA(1) >= LITERAL_void && LA(1) <= IDENT)) && (_tokenSet_6.member(LA(2)))) {
					typeSpec(false);
					if (inputState.guessing==0) {
						t_AST = (MyCommonAST)returnAST;
					}
					{
					if ((LA(1)==IDENT) && (LA(2)==LPAREN)) {
						MyCommonAST tmp39_AST = null;
						if (inputState.guessing==0) {
							tmp39_AST = (MyCommonAST)astFactory.create(LT(1));
						}
						match(IDENT);
						MyCommonAST tmp40_AST = null;
						tmp40_AST = (MyCommonAST)astFactory.create(LT(1));
						match(LPAREN);
						parameterDeclarationList(msig);
						if (inputState.guessing==0) {
							param_AST = (MyCommonAST)returnAST;
						}
						MyCommonAST tmp41_AST = null;
						tmp41_AST = (MyCommonAST)astFactory.create(LT(1));
						match(RPAREN);
						declaratorBrackets(t_AST);
						if (inputState.guessing==0) {
							rt_AST = (MyCommonAST)returnAST;
						}
						{
						switch ( LA(1)) {
						case LITERAL_throws:
						{
							throwsClause(exs);
							if (inputState.guessing==0) {
								tc_AST = (MyCommonAST)returnAST;
							}
							break;
						}
						case SEMI:
						case LCURLY:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						if ( inputState.guessing==0 ) {
							
							msig.setName(tmp39_AST);
							msig.setThrows(exs);
							msig.setReturnType(t_AST);
							ver.verifyMethod(msig);
							ver.reportStartMethodBlock();
							
						}
						{
						switch ( LA(1)) {
						case LCURLY:
						{
							compoundStatement(stmtBraces);
							if (inputState.guessing==0) {
								s2_AST = (MyCommonAST)returnAST;
							}
							if ( inputState.guessing==0 ) {
								
								ver.verifyLCurlyMethod(msig.getFirstLineNo(), stmtBraces[0]);
								ver.verifyMethodLength(
								s2_AST.getLineNo(),
								stmtBraces[1].getLineNo()
								- stmtBraces[0].getLineNo() + 1);
								
							}
							break;
						}
						case SEMI:
						{
							MyCommonAST tmp42_AST = null;
							if (inputState.guessing==0) {
								tmp42_AST = (MyCommonAST)astFactory.create(LT(1));
							}
							match(SEMI);
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						if ( inputState.guessing==0 ) {
							field_AST = (MyCommonAST)currentAST.root;
							field_AST = (MyCommonAST)astFactory.make( (new ASTArray(7)).add((MyCommonAST)astFactory.create(METHOD_DEF,"METHOD_DEF")).add(mods_AST).add((MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(TYPE,"TYPE")).add(rt_AST))).add(tmp39_AST).add(param_AST).add(tc_AST).add(s2_AST));
							currentAST.root = field_AST;
							currentAST.child = field_AST!=null &&field_AST.getFirstChild()!=null ?
								field_AST.getFirstChild() : field_AST;
							currentAST.advanceChildToEnd();
						}
						if ( inputState.guessing==0 ) {
							ver.reportEndMethodBlock();
						}
					}
					else if ((LA(1)==IDENT) && (_tokenSet_7.member(LA(2)))) {
						variableDefinitions(mods_AST,t_AST, msig.getModSet());
						if (inputState.guessing==0) {
							v_AST = (MyCommonAST)returnAST;
						}
						MyCommonAST tmp43_AST = null;
						if (inputState.guessing==0) {
							tmp43_AST = (MyCommonAST)astFactory.create(LT(1));
						}
						match(SEMI);
						if ( inputState.guessing==0 ) {
							field_AST = (MyCommonAST)currentAST.root;
							field_AST = v_AST;
							currentAST.root = field_AST;
							currentAST.child = field_AST!=null &&field_AST.getFirstChild()!=null ?
								field_AST.getFirstChild() : field_AST;
							currentAST.advanceChildToEnd();
						}
					}
					else {
						throw new NoViableAltException(LT(1), getFilename());
					}
					
					}
				}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
		}
		else if ((LA(1)==LITERAL_static) && (LA(2)==LCURLY)) {
			st = LT(1);
			if (inputState.guessing==0) {
				st_AST = (MyCommonAST)astFactory.create(st);
			}
			match(LITERAL_static);
			if ( inputState.guessing==0 ) {
				ver.reportStartMethodBlock();
			}
			compoundStatement(stmtBraces);
			if (inputState.guessing==0) {
				s3_AST = (MyCommonAST)returnAST;
			}
			if ( inputState.guessing==0 ) {
				field_AST = (MyCommonAST)currentAST.root;
				
				field_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(STATIC_INIT,"STATIC_INIT")).add(s3_AST));
				ver.reportEndMethodBlock();
				ver.verifyLCurlyOther(st.getLine(), stmtBraces[0]);
				
				currentAST.root = field_AST;
				currentAST.child = field_AST!=null &&field_AST.getFirstChild()!=null ?
					field_AST.getFirstChild() : field_AST;
				currentAST.advanceChildToEnd();
			}
		}
		else if ((LA(1)==LCURLY)) {
			if ( inputState.guessing==0 ) {
				ver.reportStartMethodBlock();
			}
			compoundStatement(sIgnoreAST);
			if (inputState.guessing==0) {
				s4_AST = (MyCommonAST)returnAST;
			}
			if ( inputState.guessing==0 ) {
				ver.reportEndMethodBlock();
			}
			if ( inputState.guessing==0 ) {
				field_AST = (MyCommonAST)currentAST.root;
				field_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(INSTANCE_INIT,"INSTANCE_INIT")).add(s4_AST));
				currentAST.root = field_AST;
				currentAST.child = field_AST!=null &&field_AST.getFirstChild()!=null ?
					field_AST.getFirstChild() : field_AST;
				currentAST.advanceChildToEnd();
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		returnAST = field_AST;
	}
	
	public final void ctorHead(
		java.util.List exs, MethodSignature msig
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST ctorHead_AST = null;
		
		MyCommonAST tmp44_AST = null;
		if (inputState.guessing==0) {
			tmp44_AST = (MyCommonAST)astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp44_AST);
		}
		match(IDENT);
		if ( inputState.guessing==0 ) {
			msig.setName(tmp44_AST);
		}
		MyCommonAST tmp45_AST = null;
		tmp45_AST = (MyCommonAST)astFactory.create(LT(1));
		match(LPAREN);
		parameterDeclarationList(msig);
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		MyCommonAST tmp46_AST = null;
		tmp46_AST = (MyCommonAST)astFactory.create(LT(1));
		match(RPAREN);
		{
		switch ( LA(1)) {
		case LITERAL_throws:
		{
			throwsClause(exs);
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			break;
		}
		case LCURLY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		ctorHead_AST = (MyCommonAST)currentAST.root;
		returnAST = ctorHead_AST;
	}
	
	public final void constructorBody(
		int aLineNo
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST constructorBody_AST = null;
		Token  lc = null;
		MyCommonAST lc_AST = null;
		Token  rc = null;
		MyCommonAST rc_AST = null;
		
		lc = LT(1);
		if (inputState.guessing==0) {
			lc_AST = (MyCommonAST)astFactory.create(lc);
			astFactory.makeASTRoot(currentAST, lc_AST);
		}
		match(LCURLY);
		if ( inputState.guessing==0 ) {
			lc_AST.setType(SLIST); ver.verifyLCurlyMethod(aLineNo, lc_AST);
		}
		{
		boolean synPredMatched55 = false;
		if (((_tokenSet_8.member(LA(1))) && (_tokenSet_9.member(LA(2))))) {
			int _m55 = mark();
			synPredMatched55 = true;
			inputState.guessing++;
			try {
				{
				explicitConstructorInvocation();
				}
			}
			catch (RecognitionException pe) {
				synPredMatched55 = false;
			}
			rewind(_m55);
			inputState.guessing--;
		}
		if ( synPredMatched55 ) {
			explicitConstructorInvocation();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
		}
		else if ((_tokenSet_10.member(LA(1))) && (_tokenSet_11.member(LA(2)))) {
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		{
		_loop57:
		do {
			if ((_tokenSet_12.member(LA(1)))) {
				statement(sIgnoreType, sIgnoreAST);
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				break _loop57;
			}
			
		} while (true);
		}
		rc = LT(1);
		if (inputState.guessing==0) {
			rc_AST = (MyCommonAST)astFactory.create(rc);
		}
		match(RCURLY);
		if ( inputState.guessing==0 ) {
			ver.verifyConstructorLength(lc_AST.getLineNo(), rc_AST.getLineNo() - lc_AST.getLineNo() + 1);
		}
		constructorBody_AST = (MyCommonAST)currentAST.root;
		returnAST = constructorBody_AST;
	}
	
	public final void parameterDeclarationList(
		MethodSignature msig
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST parameterDeclarationList_AST = null;
		
		{
		switch ( LA(1)) {
		case FINAL:
		case LITERAL_void:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_short:
		case LITERAL_int:
		case LITERAL_float:
		case LITERAL_long:
		case LITERAL_double:
		case IDENT:
		{
			parameterDeclaration(msig);
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			{
			_loop83:
			do {
				if ((LA(1)==COMMA)) {
					MyCommonAST tmp47_AST = null;
					tmp47_AST = (MyCommonAST)astFactory.create(LT(1));
					match(COMMA);
					parameterDeclaration(msig);
					if (inputState.guessing==0) {
						astFactory.addASTChild(currentAST, returnAST);
					}
				}
				else {
					break _loop83;
				}
				
			} while (true);
			}
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			parameterDeclarationList_AST = (MyCommonAST)currentAST.root;
			parameterDeclarationList_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(PARAMETERS,"PARAMETERS")).add(parameterDeclarationList_AST));
			currentAST.root = parameterDeclarationList_AST;
			currentAST.child = parameterDeclarationList_AST!=null &&parameterDeclarationList_AST.getFirstChild()!=null ?
				parameterDeclarationList_AST.getFirstChild() : parameterDeclarationList_AST;
			currentAST.advanceChildToEnd();
		}
		parameterDeclarationList_AST = (MyCommonAST)currentAST.root;
		returnAST = parameterDeclarationList_AST;
	}
	
	public final void declaratorBrackets(
		MyCommonAST typ
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST declaratorBrackets_AST = null;
		Token  lb = null;
		MyCommonAST lb_AST = null;
		
		if ( inputState.guessing==0 ) {
			declaratorBrackets_AST = (MyCommonAST)currentAST.root;
			declaratorBrackets_AST=typ;
			currentAST.root = declaratorBrackets_AST;
			currentAST.child = declaratorBrackets_AST!=null &&declaratorBrackets_AST.getFirstChild()!=null ?
				declaratorBrackets_AST.getFirstChild() : declaratorBrackets_AST;
			currentAST.advanceChildToEnd();
		}
		{
		_loop66:
		do {
			if ((LA(1)==LBRACK)) {
				lb = LT(1);
				if (inputState.guessing==0) {
					lb_AST = (MyCommonAST)astFactory.create(lb);
					astFactory.makeASTRoot(currentAST, lb_AST);
				}
				match(LBRACK);
				if ( inputState.guessing==0 ) {
					lb_AST.setType(ARRAY_DECLARATOR);
				}
				MyCommonAST tmp48_AST = null;
				tmp48_AST = (MyCommonAST)astFactory.create(LT(1));
				match(RBRACK);
			}
			else {
				break _loop66;
			}
			
		} while (true);
		}
		declaratorBrackets_AST = (MyCommonAST)currentAST.root;
		returnAST = declaratorBrackets_AST;
	}
	
	public final void throwsClause(
		java.util.List exs
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST throwsClause_AST = null;
		MyCommonAST i1_AST = null;
		MyCommonAST i2_AST = null;
		
		MyCommonAST tmp49_AST = null;
		if (inputState.guessing==0) {
			tmp49_AST = (MyCommonAST)astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp49_AST);
		}
		match(LITERAL_throws);
		identifier();
		if (inputState.guessing==0) {
			i1_AST = (MyCommonAST)returnAST;
			astFactory.addASTChild(currentAST, returnAST);
		}
		if ( inputState.guessing==0 ) {
			exs.add(sLastIdentifier);
		}
		{
		_loop79:
		do {
			if ((LA(1)==COMMA)) {
				MyCommonAST tmp50_AST = null;
				tmp50_AST = (MyCommonAST)astFactory.create(LT(1));
				match(COMMA);
				identifier();
				if (inputState.guessing==0) {
					i2_AST = (MyCommonAST)returnAST;
					astFactory.addASTChild(currentAST, returnAST);
				}
				if ( inputState.guessing==0 ) {
					exs.add(sLastIdentifier);
				}
			}
			else {
				break _loop79;
			}
			
		} while (true);
		}
		throwsClause_AST = (MyCommonAST)currentAST.root;
		returnAST = throwsClause_AST;
	}
	
	public final void compoundStatement(
		MyCommonAST[] aCurlies
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST compoundStatement_AST = null;
		Token  lc = null;
		MyCommonAST lc_AST = null;
		Token  rc = null;
		MyCommonAST rc_AST = null;
		
		lc = LT(1);
		if (inputState.guessing==0) {
			lc_AST = (MyCommonAST)astFactory.create(lc);
			astFactory.makeASTRoot(currentAST, lc_AST);
		}
		match(LCURLY);
		if ( inputState.guessing==0 ) {
			lc_AST.setType(SLIST); aCurlies[0] = lc_AST;
		}
		{
		_loop89:
		do {
			if ((_tokenSet_12.member(LA(1)))) {
				statement(sIgnoreType, sIgnoreAST);
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				break _loop89;
			}
			
		} while (true);
		}
		rc = LT(1);
		if (inputState.guessing==0) {
			rc_AST = (MyCommonAST)astFactory.create(rc);
		}
		match(RCURLY);
		if ( inputState.guessing==0 ) {
			aCurlies[1] = rc_AST;
		}
		compoundStatement_AST = (MyCommonAST)currentAST.root;
		returnAST = compoundStatement_AST;
	}
	
	public final void explicitConstructorInvocation() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST explicitConstructorInvocation_AST = null;
		Token  lp1 = null;
		MyCommonAST lp1_AST = null;
		Token  lp2 = null;
		MyCommonAST lp2_AST = null;
		Token  lp3 = null;
		MyCommonAST lp3_AST = null;
		
		{
		if ((LA(1)==LITERAL_this) && (LA(2)==LPAREN)) {
			MyCommonAST tmp51_AST = null;
			tmp51_AST = (MyCommonAST)astFactory.create(LT(1));
			match(LITERAL_this);
			lp1 = LT(1);
			if (inputState.guessing==0) {
				lp1_AST = (MyCommonAST)astFactory.create(lp1);
				astFactory.makeASTRoot(currentAST, lp1_AST);
			}
			match(LPAREN);
			argList();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			MyCommonAST tmp52_AST = null;
			tmp52_AST = (MyCommonAST)astFactory.create(LT(1));
			match(RPAREN);
			MyCommonAST tmp53_AST = null;
			tmp53_AST = (MyCommonAST)astFactory.create(LT(1));
			match(SEMI);
			if ( inputState.guessing==0 ) {
				lp1_AST.setType(CTOR_CALL);
			}
		}
		else if ((LA(1)==LITERAL_super) && (LA(2)==LPAREN)) {
			MyCommonAST tmp54_AST = null;
			tmp54_AST = (MyCommonAST)astFactory.create(LT(1));
			match(LITERAL_super);
			lp2 = LT(1);
			if (inputState.guessing==0) {
				lp2_AST = (MyCommonAST)astFactory.create(lp2);
				astFactory.makeASTRoot(currentAST, lp2_AST);
			}
			match(LPAREN);
			argList();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			MyCommonAST tmp55_AST = null;
			tmp55_AST = (MyCommonAST)astFactory.create(LT(1));
			match(RPAREN);
			MyCommonAST tmp56_AST = null;
			tmp56_AST = (MyCommonAST)astFactory.create(LT(1));
			match(SEMI);
			if ( inputState.guessing==0 ) {
				lp2_AST.setType(SUPER_CTOR_CALL);
			}
		}
		else if ((_tokenSet_8.member(LA(1))) && (_tokenSet_9.member(LA(2)))) {
			primaryExpression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			MyCommonAST tmp57_AST = null;
			tmp57_AST = (MyCommonAST)astFactory.create(LT(1));
			match(DOT);
			if ( inputState.guessing==0 ) {
				ver.verifyDot(tmp57_AST);
			}
			MyCommonAST tmp58_AST = null;
			tmp58_AST = (MyCommonAST)astFactory.create(LT(1));
			match(LITERAL_super);
			lp3 = LT(1);
			if (inputState.guessing==0) {
				lp3_AST = (MyCommonAST)astFactory.create(lp3);
				astFactory.makeASTRoot(currentAST, lp3_AST);
			}
			match(LPAREN);
			argList();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			MyCommonAST tmp59_AST = null;
			tmp59_AST = (MyCommonAST)astFactory.create(LT(1));
			match(RPAREN);
			MyCommonAST tmp60_AST = null;
			tmp60_AST = (MyCommonAST)astFactory.create(LT(1));
			match(SEMI);
			if ( inputState.guessing==0 ) {
				lp3_AST.setType(SUPER_CTOR_CALL);
			}
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		explicitConstructorInvocation_AST = (MyCommonAST)currentAST.root;
		returnAST = explicitConstructorInvocation_AST;
	}
	
	public final void statement(
		int[] aType, MyCommonAST[] aCurlies
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST statement_AST = null;
		
		traditionalStatement(aType, aCurlies);
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		statement_AST = (MyCommonAST)currentAST.root;
		returnAST = statement_AST;
	}
	
	public final void argList() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST argList_AST = null;
		
		{
		switch ( LA(1)) {
		case LITERAL_void:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_short:
		case LITERAL_int:
		case LITERAL_float:
		case LITERAL_long:
		case LITERAL_double:
		case IDENT:
		case LPAREN:
		case LITERAL_this:
		case LITERAL_super:
		case PLUS:
		case MINUS:
		case INC:
		case DEC:
		case BNOT:
		case LNOT:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case NUM_INT:
		case CHAR_LITERAL:
		case STRING_LITERAL:
		case NUM_FLOAT:
		case NUM_LONG:
		case NUM_DOUBLE:
		{
			expressionList();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			break;
		}
		case RPAREN:
		{
			if ( inputState.guessing==0 ) {
				argList_AST = (MyCommonAST)currentAST.root;
				argList_AST = (MyCommonAST)astFactory.create(ELIST,"ELIST");
				currentAST.root = argList_AST;
				currentAST.child = argList_AST!=null &&argList_AST.getFirstChild()!=null ?
					argList_AST.getFirstChild() : argList_AST;
				currentAST.advanceChildToEnd();
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		argList_AST = (MyCommonAST)currentAST.root;
		returnAST = argList_AST;
	}
	
	public final void primaryExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST primaryExpression_AST = null;
		Token  i1 = null;
		MyCommonAST i1_AST = null;
		Token  lbt = null;
		MyCommonAST lbt_AST = null;
		
		switch ( LA(1)) {
		case IDENT:
		{
			i1 = LT(1);
			if (inputState.guessing==0) {
				i1_AST = (MyCommonAST)astFactory.create(i1);
				astFactory.addASTChild(currentAST, i1_AST);
			}
			match(IDENT);
			if ( inputState.guessing==0 ) {
				sFirstIdent = i1.getText();
			}
			primaryExpression_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case NUM_INT:
		case CHAR_LITERAL:
		case STRING_LITERAL:
		case NUM_FLOAT:
		case NUM_LONG:
		case NUM_DOUBLE:
		{
			constant();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			primaryExpression_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_true:
		{
			MyCommonAST tmp61_AST = null;
			if (inputState.guessing==0) {
				tmp61_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp61_AST);
			}
			match(LITERAL_true);
			primaryExpression_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_false:
		{
			MyCommonAST tmp62_AST = null;
			if (inputState.guessing==0) {
				tmp62_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp62_AST);
			}
			match(LITERAL_false);
			primaryExpression_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_this:
		{
			MyCommonAST tmp63_AST = null;
			if (inputState.guessing==0) {
				tmp63_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp63_AST);
			}
			match(LITERAL_this);
			primaryExpression_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_null:
		{
			MyCommonAST tmp64_AST = null;
			if (inputState.guessing==0) {
				tmp64_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp64_AST);
			}
			match(LITERAL_null);
			primaryExpression_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_new:
		{
			newExpression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			primaryExpression_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LPAREN:
		{
			MyCommonAST tmp65_AST = null;
			tmp65_AST = (MyCommonAST)astFactory.create(LT(1));
			match(LPAREN);
			assignmentExpression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			MyCommonAST tmp66_AST = null;
			tmp66_AST = (MyCommonAST)astFactory.create(LT(1));
			match(RPAREN);
			primaryExpression_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_super:
		{
			MyCommonAST tmp67_AST = null;
			if (inputState.guessing==0) {
				tmp67_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp67_AST);
			}
			match(LITERAL_super);
			primaryExpression_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_void:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_short:
		case LITERAL_int:
		case LITERAL_float:
		case LITERAL_long:
		case LITERAL_double:
		{
			builtInType();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			{
			_loop179:
			do {
				if ((LA(1)==LBRACK)) {
					lbt = LT(1);
					if (inputState.guessing==0) {
						lbt_AST = (MyCommonAST)astFactory.create(lbt);
						astFactory.makeASTRoot(currentAST, lbt_AST);
					}
					match(LBRACK);
					if ( inputState.guessing==0 ) {
						lbt_AST.setType(ARRAY_DECLARATOR);
					}
					MyCommonAST tmp68_AST = null;
					tmp68_AST = (MyCommonAST)astFactory.create(LT(1));
					match(RBRACK);
				}
				else {
					break _loop179;
				}
				
			} while (true);
			}
			MyCommonAST tmp69_AST = null;
			if (inputState.guessing==0) {
				tmp69_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp69_AST);
			}
			match(DOT);
			MyCommonAST tmp70_AST = null;
			if (inputState.guessing==0) {
				tmp70_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp70_AST);
			}
			match(LITERAL_class);
			if ( inputState.guessing==0 ) {
				ver.verifyDot(tmp69_AST);
			}
			primaryExpression_AST = (MyCommonAST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = primaryExpression_AST;
	}
	
/** Declaration of a variable.  This can be a class/instance variable,
 *   or a local variable in a method
 * It can also include possible initialization.
 */
	public final void variableDeclarator(
		MyCommonAST mods, MyCommonAST t, MyModifierSet modSet
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST variableDeclarator_AST = null;
		Token  id = null;
		MyCommonAST id_AST = null;
		MyCommonAST d_AST = null;
		MyCommonAST v_AST = null;
		
		id = LT(1);
		if (inputState.guessing==0) {
			id_AST = (MyCommonAST)astFactory.create(id);
		}
		match(IDENT);
		declaratorBrackets(t);
		if (inputState.guessing==0) {
			d_AST = (MyCommonAST)returnAST;
		}
		varInitializer();
		if (inputState.guessing==0) {
			v_AST = (MyCommonAST)returnAST;
		}
		if ( inputState.guessing==0 ) {
			variableDeclarator_AST = (MyCommonAST)currentAST.root;
			variableDeclarator_AST = (MyCommonAST)astFactory.make( (new ASTArray(5)).add((MyCommonAST)astFactory.create(VARIABLE_DEF,"VARIABLE_DEF")).add(mods).add((MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(TYPE,"TYPE")).add(d_AST))).add(id_AST).add(v_AST));
			currentAST.root = variableDeclarator_AST;
			currentAST.child = variableDeclarator_AST!=null &&variableDeclarator_AST.getFirstChild()!=null ?
				variableDeclarator_AST.getFirstChild() : variableDeclarator_AST;
			currentAST.advanceChildToEnd();
		}
		if ( inputState.guessing==0 ) {
			
			ver.verifyVariable(new MyVariable(new LineText(id.getLine(), id.getColumn(), id.getText()), modSet));
			
		}
		returnAST = variableDeclarator_AST;
	}
	
	public final void varInitializer() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST varInitializer_AST = null;
		
		{
		switch ( LA(1)) {
		case ASSIGN:
		{
			MyCommonAST tmp71_AST = null;
			if (inputState.guessing==0) {
				tmp71_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp71_AST);
			}
			match(ASSIGN);
			initializer();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			break;
		}
		case SEMI:
		case COMMA:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		varInitializer_AST = (MyCommonAST)currentAST.root;
		returnAST = varInitializer_AST;
	}
	
	public final void initializer() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST initializer_AST = null;
		
		switch ( LA(1)) {
		case LITERAL_void:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_short:
		case LITERAL_int:
		case LITERAL_float:
		case LITERAL_long:
		case LITERAL_double:
		case IDENT:
		case LPAREN:
		case LITERAL_this:
		case LITERAL_super:
		case PLUS:
		case MINUS:
		case INC:
		case DEC:
		case BNOT:
		case LNOT:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case NUM_INT:
		case CHAR_LITERAL:
		case STRING_LITERAL:
		case NUM_FLOAT:
		case NUM_LONG:
		case NUM_DOUBLE:
		{
			expression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			initializer_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LCURLY:
		{
			arrayInitializer();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			initializer_AST = (MyCommonAST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = initializer_AST;
	}
	
	public final void arrayInitializer() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST arrayInitializer_AST = null;
		Token  lc = null;
		MyCommonAST lc_AST = null;
		
		lc = LT(1);
		if (inputState.guessing==0) {
			lc_AST = (MyCommonAST)astFactory.create(lc);
			astFactory.makeASTRoot(currentAST, lc_AST);
		}
		match(LCURLY);
		if ( inputState.guessing==0 ) {
			lc_AST.setType(ARRAY_INIT);
		}
		{
		switch ( LA(1)) {
		case LITERAL_void:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_short:
		case LITERAL_int:
		case LITERAL_float:
		case LITERAL_long:
		case LITERAL_double:
		case IDENT:
		case LCURLY:
		case LPAREN:
		case LITERAL_this:
		case LITERAL_super:
		case PLUS:
		case MINUS:
		case INC:
		case DEC:
		case BNOT:
		case LNOT:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case NUM_INT:
		case CHAR_LITERAL:
		case STRING_LITERAL:
		case NUM_FLOAT:
		case NUM_LONG:
		case NUM_DOUBLE:
		{
			initializer();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			{
			_loop72:
			do {
				if ((LA(1)==COMMA) && (_tokenSet_13.member(LA(2)))) {
					MyCommonAST tmp72_AST = null;
					tmp72_AST = (MyCommonAST)astFactory.create(LT(1));
					match(COMMA);
					initializer();
					if (inputState.guessing==0) {
						astFactory.addASTChild(currentAST, returnAST);
					}
				}
				else {
					break _loop72;
				}
				
			} while (true);
			}
			{
			switch ( LA(1)) {
			case COMMA:
			{
				MyCommonAST tmp73_AST = null;
				tmp73_AST = (MyCommonAST)astFactory.create(LT(1));
				match(COMMA);
				break;
			}
			case RCURLY:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case RCURLY:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		MyCommonAST tmp74_AST = null;
		tmp74_AST = (MyCommonAST)astFactory.create(LT(1));
		match(RCURLY);
		arrayInitializer_AST = (MyCommonAST)currentAST.root;
		returnAST = arrayInitializer_AST;
	}
	
	public final void expression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST expression_AST = null;
		
		assignmentExpression();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		if ( inputState.guessing==0 ) {
			expression_AST = (MyCommonAST)currentAST.root;
			expression_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(EXPR,"EXPR")).add(expression_AST));
			currentAST.root = expression_AST;
			currentAST.child = expression_AST!=null &&expression_AST.getFirstChild()!=null ?
				expression_AST.getFirstChild() : expression_AST;
			currentAST.advanceChildToEnd();
		}
		expression_AST = (MyCommonAST)currentAST.root;
		returnAST = expression_AST;
	}
	
	public final void parameterDeclaration(
		MethodSignature msig
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST parameterDeclaration_AST = null;
		MyCommonAST pm_AST = null;
		MyCommonAST t_AST = null;
		Token  id = null;
		MyCommonAST id_AST = null;
		MyCommonAST pd_AST = null;
		
		parameterModifier();
		if (inputState.guessing==0) {
			pm_AST = (MyCommonAST)returnAST;
		}
		typeSpec(false);
		if (inputState.guessing==0) {
			t_AST = (MyCommonAST)returnAST;
		}
		id = LT(1);
		if (inputState.guessing==0) {
			id_AST = (MyCommonAST)astFactory.create(id);
		}
		match(IDENT);
		declaratorBrackets(t_AST);
		if (inputState.guessing==0) {
			pd_AST = (MyCommonAST)returnAST;
		}
		if ( inputState.guessing==0 ) {
			parameterDeclaration_AST = (MyCommonAST)currentAST.root;
			parameterDeclaration_AST = (MyCommonAST)astFactory.make( (new ASTArray(4)).add((MyCommonAST)astFactory.create(PARAMETER_DEF,"PARAMETER_DEF")).add(pm_AST).add((MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(TYPE,"TYPE")).add(pd_AST))).add(id_AST));
			currentAST.root = parameterDeclaration_AST;
			currentAST.child = parameterDeclaration_AST!=null &&parameterDeclaration_AST.getFirstChild()!=null ?
				parameterDeclaration_AST.getFirstChild() : parameterDeclaration_AST;
			currentAST.advanceChildToEnd();
		}
		if ( inputState.guessing==0 ) {
			
			msig.addParam(new LineText(id_AST.getLineNo(), id_AST.getColumnNo(), id_AST.getText()));
			
		}
		returnAST = parameterDeclaration_AST;
	}
	
	public final void parameterModifier() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST parameterModifier_AST = null;
		Token  f = null;
		MyCommonAST f_AST = null;
		
		{
		switch ( LA(1)) {
		case FINAL:
		{
			f = LT(1);
			if (inputState.guessing==0) {
				f_AST = (MyCommonAST)astFactory.create(f);
				astFactory.addASTChild(currentAST, f_AST);
			}
			match(FINAL);
			break;
		}
		case LITERAL_void:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_short:
		case LITERAL_int:
		case LITERAL_float:
		case LITERAL_long:
		case LITERAL_double:
		case IDENT:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			parameterModifier_AST = (MyCommonAST)currentAST.root;
			parameterModifier_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(MODIFIERS,"MODIFIERS")).add(f_AST));
			currentAST.root = parameterModifier_AST;
			currentAST.child = parameterModifier_AST!=null &&parameterModifier_AST.getFirstChild()!=null ?
				parameterModifier_AST.getFirstChild() : parameterModifier_AST;
			currentAST.advanceChildToEnd();
		}
		parameterModifier_AST = (MyCommonAST)currentAST.root;
		returnAST = parameterModifier_AST;
	}
	
	public final void traditionalStatement(
		int[] aType, MyCommonAST[] aCurlies
	) throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST traditionalStatement_AST = null;
		MyCommonAST m_AST = null;
		Token  c = null;
		MyCommonAST c_AST = null;
		Token  ii = null;
		MyCommonAST ii_AST = null;
		Token  ee = null;
		MyCommonAST ee_AST = null;
		Token  ff = null;
		MyCommonAST ff_AST = null;
		Token  s1 = null;
		MyCommonAST s1_AST = null;
		Token  s2 = null;
		MyCommonAST s2_AST = null;
		Token  ww = null;
		MyCommonAST ww_AST = null;
		Token  dd = null;
		MyCommonAST dd_AST = null;
		Token  dw = null;
		MyCommonAST dw_AST = null;
		Token  rr = null;
		MyCommonAST rr_AST = null;
		Token  ss2 = null;
		MyCommonAST ss2_AST = null;
		Token  lc = null;
		MyCommonAST lc_AST = null;
		Token  ss = null;
		MyCommonAST ss_AST = null;
		Token  s = null;
		MyCommonAST s_AST = null;
		
		final MyModifierSet modSet = new MyModifierSet();
		final int[] stmtType = new int[1];
		final MyCommonAST[] stmtBraces = new MyCommonAST[2];
		stmtType[0] = STMT_OTHER;
		
		
		switch ( LA(1)) {
		case LCURLY:
		{
			compoundStatement(aCurlies);
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			if ( inputState.guessing==0 ) {
				aType[0] = STMT_COMPOUND;
			}
			traditionalStatement_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_if:
		{
			ii = LT(1);
			if (inputState.guessing==0) {
				ii_AST = (MyCommonAST)astFactory.create(ii);
				astFactory.makeASTRoot(currentAST, ii_AST);
			}
			match(LITERAL_if);
			MyCommonAST tmp75_AST = null;
			tmp75_AST = (MyCommonAST)astFactory.create(LT(1));
			match(LPAREN);
			expression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			MyCommonAST tmp76_AST = null;
			tmp76_AST = (MyCommonAST)astFactory.create(LT(1));
			match(RPAREN);
			statement(stmtType, stmtBraces);
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			if ( inputState.guessing==0 ) {
				
				aType[0] = STMT_IF;
				ver.verifyWSAroundBegin(ii.getLine(), ii.getColumn(), ii.getText());
				if (stmtType[0] != STMT_COMPOUND) {
				ver.reportNeedBraces(ii);
				}
				else {
				ver.verifyLCurlyOther(ii.getLine(), stmtBraces[0]);
				}
				
			}
			{
			if ((LA(1)==LITERAL_else) && (_tokenSet_12.member(LA(2)))) {
				ee = LT(1);
				if (inputState.guessing==0) {
					ee_AST = (MyCommonAST)astFactory.create(ee);
				}
				match(LITERAL_else);
				if ( inputState.guessing==0 ) {
					
					if (stmtType[0] == STMT_COMPOUND) {
					ver.verifyRCurly(stmtBraces[1], ee.getLine());
					}
					stmtType[0] = STMT_OTHER;
					
				}
				statement(stmtType, stmtBraces);
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
				if ( inputState.guessing==0 ) {
					
					ver.verifyWSAroundBegin(ee.getLine(), ee.getColumn(), ee.getText());
					if (stmtType[0] == STMT_OTHER) {
					ver.reportNeedBraces(ee);
					}
					else if (stmtType[0] == STMT_COMPOUND) {
					ver.verifyLCurlyOther(ee.getLine(), stmtBraces[0]);
					}
					
				}
			}
			else if ((_tokenSet_14.member(LA(1))) && (_tokenSet_15.member(LA(2)))) {
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
			traditionalStatement_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_for:
		{
			ff = LT(1);
			if (inputState.guessing==0) {
				ff_AST = (MyCommonAST)astFactory.create(ff);
				astFactory.makeASTRoot(currentAST, ff_AST);
			}
			match(LITERAL_for);
			MyCommonAST tmp77_AST = null;
			tmp77_AST = (MyCommonAST)astFactory.create(LT(1));
			match(LPAREN);
			forInit();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			s1 = LT(1);
			if (inputState.guessing==0) {
				s1_AST = (MyCommonAST)astFactory.create(s1);
			}
			match(SEMI);
			forCond();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			s2 = LT(1);
			if (inputState.guessing==0) {
				s2_AST = (MyCommonAST)astFactory.create(s2);
			}
			match(SEMI);
			forIter();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			MyCommonAST tmp78_AST = null;
			tmp78_AST = (MyCommonAST)astFactory.create(LT(1));
			match(RPAREN);
			statement(stmtType, stmtBraces);
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			if ( inputState.guessing==0 ) {
				
				ver.verifyWSAroundBegin(ff.getLine(), ff.getColumn(), ff.getText());
				ver.verifyWSAfter(s1.getLine(), s1.getColumn(), MyToken.SEMI_COLON);
				ver.verifyWSAfter(s2.getLine(), s2.getColumn(), MyToken.SEMI_COLON, ")");
				if (stmtType[0] != STMT_COMPOUND) {
				ver.reportNeedBraces(ff);
				}
				else {
				ver.verifyLCurlyOther(ff.getLine(), stmtBraces[0]);
				}
				
			}
			traditionalStatement_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_while:
		{
			ww = LT(1);
			if (inputState.guessing==0) {
				ww_AST = (MyCommonAST)astFactory.create(ww);
				astFactory.makeASTRoot(currentAST, ww_AST);
			}
			match(LITERAL_while);
			MyCommonAST tmp79_AST = null;
			tmp79_AST = (MyCommonAST)astFactory.create(LT(1));
			match(LPAREN);
			expression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			MyCommonAST tmp80_AST = null;
			tmp80_AST = (MyCommonAST)astFactory.create(LT(1));
			match(RPAREN);
			statement(stmtType, stmtBraces);
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			if ( inputState.guessing==0 ) {
				
				ver.verifyWSAroundBegin(ww.getLine(), ww.getColumn(), ww.getText());
				if (stmtType[0] != STMT_COMPOUND) {
				ver.reportNeedBraces(ww);
				}
				else {
				ver.verifyLCurlyOther(ww.getLine(), stmtBraces[0]);
				}
				
			}
			traditionalStatement_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_do:
		{
			dd = LT(1);
			if (inputState.guessing==0) {
				dd_AST = (MyCommonAST)astFactory.create(dd);
				astFactory.makeASTRoot(currentAST, dd_AST);
			}
			match(LITERAL_do);
			statement(stmtType, stmtBraces);
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			dw = LT(1);
			if (inputState.guessing==0) {
				dw_AST = (MyCommonAST)astFactory.create(dw);
			}
			match(LITERAL_while);
			MyCommonAST tmp81_AST = null;
			tmp81_AST = (MyCommonAST)astFactory.create(LT(1));
			match(LPAREN);
			expression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			MyCommonAST tmp82_AST = null;
			tmp82_AST = (MyCommonAST)astFactory.create(LT(1));
			match(RPAREN);
			MyCommonAST tmp83_AST = null;
			tmp83_AST = (MyCommonAST)astFactory.create(LT(1));
			match(SEMI);
			if ( inputState.guessing==0 ) {
				
				ver.verifyWSAroundBegin(dd.getLine(), dd.getColumn(), dd.getText());
				ver.verifyWSAroundBegin(dw.getLine(), dw.getColumn(), dw.getText());
				if (stmtType[0] != STMT_COMPOUND) {
				ver.reportNeedBraces(dd);
				}
				else {
				ver.verifyLCurlyOther(dd.getLine(), stmtBraces[0]);
				}
				
			}
			traditionalStatement_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_break:
		{
			MyCommonAST tmp84_AST = null;
			if (inputState.guessing==0) {
				tmp84_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp84_AST);
			}
			match(LITERAL_break);
			{
			switch ( LA(1)) {
			case IDENT:
			{
				MyCommonAST tmp85_AST = null;
				if (inputState.guessing==0) {
					tmp85_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp85_AST);
				}
				match(IDENT);
				break;
			}
			case SEMI:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			MyCommonAST tmp86_AST = null;
			tmp86_AST = (MyCommonAST)astFactory.create(LT(1));
			match(SEMI);
			traditionalStatement_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_continue:
		{
			MyCommonAST tmp87_AST = null;
			if (inputState.guessing==0) {
				tmp87_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp87_AST);
			}
			match(LITERAL_continue);
			{
			switch ( LA(1)) {
			case IDENT:
			{
				MyCommonAST tmp88_AST = null;
				if (inputState.guessing==0) {
					tmp88_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp88_AST);
				}
				match(IDENT);
				break;
			}
			case SEMI:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			MyCommonAST tmp89_AST = null;
			tmp89_AST = (MyCommonAST)astFactory.create(LT(1));
			match(SEMI);
			traditionalStatement_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_return:
		{
			rr = LT(1);
			if (inputState.guessing==0) {
				rr_AST = (MyCommonAST)astFactory.create(rr);
				astFactory.makeASTRoot(currentAST, rr_AST);
			}
			match(LITERAL_return);
			{
			switch ( LA(1)) {
			case LITERAL_void:
			case LITERAL_boolean:
			case LITERAL_byte:
			case LITERAL_char:
			case LITERAL_short:
			case LITERAL_int:
			case LITERAL_float:
			case LITERAL_long:
			case LITERAL_double:
			case IDENT:
			case LPAREN:
			case LITERAL_this:
			case LITERAL_super:
			case PLUS:
			case MINUS:
			case INC:
			case DEC:
			case BNOT:
			case LNOT:
			case LITERAL_true:
			case LITERAL_false:
			case LITERAL_null:
			case LITERAL_new:
			case NUM_INT:
			case CHAR_LITERAL:
			case STRING_LITERAL:
			case NUM_FLOAT:
			case NUM_LONG:
			case NUM_DOUBLE:
			{
				expression();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
				if ( inputState.guessing==0 ) {
					ver.verifyWSAroundBegin(rr.getLine(), rr.getColumn(), rr.getText());
				}
				break;
			}
			case SEMI:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			MyCommonAST tmp90_AST = null;
			tmp90_AST = (MyCommonAST)astFactory.create(LT(1));
			match(SEMI);
			traditionalStatement_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_switch:
		{
			ss2 = LT(1);
			if (inputState.guessing==0) {
				ss2_AST = (MyCommonAST)astFactory.create(ss2);
				astFactory.makeASTRoot(currentAST, ss2_AST);
			}
			match(LITERAL_switch);
			MyCommonAST tmp91_AST = null;
			tmp91_AST = (MyCommonAST)astFactory.create(LT(1));
			match(LPAREN);
			expression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			MyCommonAST tmp92_AST = null;
			tmp92_AST = (MyCommonAST)astFactory.create(LT(1));
			match(RPAREN);
			lc = LT(1);
			if (inputState.guessing==0) {
				lc_AST = (MyCommonAST)astFactory.create(lc);
			}
			match(LCURLY);
			if ( inputState.guessing==0 ) {
				ver.verifyLCurlyOther(ss2.getLine(), lc_AST);
			}
			{
			_loop99:
			do {
				if ((LA(1)==LITERAL_case||LA(1)==LITERAL_default)) {
					casesGroup();
					if (inputState.guessing==0) {
						astFactory.addASTChild(currentAST, returnAST);
					}
				}
				else {
					break _loop99;
				}
				
			} while (true);
			}
			MyCommonAST tmp93_AST = null;
			tmp93_AST = (MyCommonAST)astFactory.create(LT(1));
			match(RCURLY);
			traditionalStatement_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_try:
		{
			tryBlock();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			traditionalStatement_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_throw:
		{
			MyCommonAST tmp94_AST = null;
			if (inputState.guessing==0) {
				tmp94_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp94_AST);
			}
			match(LITERAL_throw);
			expression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			MyCommonAST tmp95_AST = null;
			tmp95_AST = (MyCommonAST)astFactory.create(LT(1));
			match(SEMI);
			traditionalStatement_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case SEMI:
		{
			s = LT(1);
			if (inputState.guessing==0) {
				s_AST = (MyCommonAST)astFactory.create(s);
				astFactory.addASTChild(currentAST, s_AST);
			}
			match(SEMI);
			if ( inputState.guessing==0 ) {
				s_AST.setType(EMPTY_STAT);
			}
			traditionalStatement_AST = (MyCommonAST)currentAST.root;
			break;
		}
		default:
			boolean synPredMatched93 = false;
			if (((_tokenSet_16.member(LA(1))) && (_tokenSet_17.member(LA(2))))) {
				int _m93 = mark();
				synPredMatched93 = true;
				inputState.guessing++;
				try {
					{
					declaration();
					}
				}
				catch (RecognitionException pe) {
					synPredMatched93 = false;
				}
				rewind(_m93);
				inputState.guessing--;
			}
			if ( synPredMatched93 ) {
				declaration();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
				MyCommonAST tmp96_AST = null;
				tmp96_AST = (MyCommonAST)astFactory.create(LT(1));
				match(SEMI);
				traditionalStatement_AST = (MyCommonAST)currentAST.root;
			}
			else if ((_tokenSet_18.member(LA(1))) && (_tokenSet_19.member(LA(2)))) {
				expression();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
				MyCommonAST tmp97_AST = null;
				tmp97_AST = (MyCommonAST)astFactory.create(LT(1));
				match(SEMI);
				traditionalStatement_AST = (MyCommonAST)currentAST.root;
			}
			else if ((_tokenSet_20.member(LA(1))) && (_tokenSet_21.member(LA(2)))) {
				modifiers(modSet);
				if (inputState.guessing==0) {
					m_AST = (MyCommonAST)returnAST;
				}
				classDefinition(m_AST, modSet);
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
				traditionalStatement_AST = (MyCommonAST)currentAST.root;
			}
			else if ((LA(1)==IDENT) && (LA(2)==COLON)) {
				MyCommonAST tmp98_AST = null;
				if (inputState.guessing==0) {
					tmp98_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp98_AST);
				}
				match(IDENT);
				c = LT(1);
				if (inputState.guessing==0) {
					c_AST = (MyCommonAST)astFactory.create(c);
					astFactory.makeASTRoot(currentAST, c_AST);
				}
				match(COLON);
				if ( inputState.guessing==0 ) {
					c_AST.setType(LABELED_STAT);
				}
				statement(sIgnoreType, sIgnoreAST);
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
				traditionalStatement_AST = (MyCommonAST)currentAST.root;
			}
			else if ((LA(1)==LITERAL_synchronized) && (LA(2)==LPAREN)) {
				ss = LT(1);
				if (inputState.guessing==0) {
					ss_AST = (MyCommonAST)astFactory.create(ss);
					astFactory.makeASTRoot(currentAST, ss_AST);
				}
				match(LITERAL_synchronized);
				MyCommonAST tmp99_AST = null;
				tmp99_AST = (MyCommonAST)astFactory.create(LT(1));
				match(LPAREN);
				expression();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
				MyCommonAST tmp100_AST = null;
				tmp100_AST = (MyCommonAST)astFactory.create(LT(1));
				match(RPAREN);
				compoundStatement(stmtBraces);
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
				if ( inputState.guessing==0 ) {
					
					ver.verifyWSAroundBegin(ss.getLine(), ss.getColumn(), ss.getText());
					ver.verifyLCurlyOther(ss.getLine(), stmtBraces[0]);
					
				}
				traditionalStatement_AST = (MyCommonAST)currentAST.root;
			}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = traditionalStatement_AST;
	}
	
	public final void forInit() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST forInit_AST = null;
		
		{
		boolean synPredMatched111 = false;
		if (((_tokenSet_16.member(LA(1))) && (_tokenSet_17.member(LA(2))))) {
			int _m111 = mark();
			synPredMatched111 = true;
			inputState.guessing++;
			try {
				{
				declaration();
				}
			}
			catch (RecognitionException pe) {
				synPredMatched111 = false;
			}
			rewind(_m111);
			inputState.guessing--;
		}
		if ( synPredMatched111 ) {
			declaration();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
		}
		else if ((_tokenSet_18.member(LA(1))) && (_tokenSet_22.member(LA(2)))) {
			expressionList();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
		}
		else if ((LA(1)==SEMI)) {
		}
		else {
			throw new NoViableAltException(LT(1), getFilename());
		}
		
		}
		if ( inputState.guessing==0 ) {
			forInit_AST = (MyCommonAST)currentAST.root;
			forInit_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(FOR_INIT,"FOR_INIT")).add(forInit_AST));
			currentAST.root = forInit_AST;
			currentAST.child = forInit_AST!=null &&forInit_AST.getFirstChild()!=null ?
				forInit_AST.getFirstChild() : forInit_AST;
			currentAST.advanceChildToEnd();
		}
		forInit_AST = (MyCommonAST)currentAST.root;
		returnAST = forInit_AST;
	}
	
	public final void forCond() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST forCond_AST = null;
		
		{
		switch ( LA(1)) {
		case LITERAL_void:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_short:
		case LITERAL_int:
		case LITERAL_float:
		case LITERAL_long:
		case LITERAL_double:
		case IDENT:
		case LPAREN:
		case LITERAL_this:
		case LITERAL_super:
		case PLUS:
		case MINUS:
		case INC:
		case DEC:
		case BNOT:
		case LNOT:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case NUM_INT:
		case CHAR_LITERAL:
		case STRING_LITERAL:
		case NUM_FLOAT:
		case NUM_LONG:
		case NUM_DOUBLE:
		{
			expression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			break;
		}
		case SEMI:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			forCond_AST = (MyCommonAST)currentAST.root;
			forCond_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(FOR_CONDITION,"FOR_CONDITION")).add(forCond_AST));
			currentAST.root = forCond_AST;
			currentAST.child = forCond_AST!=null &&forCond_AST.getFirstChild()!=null ?
				forCond_AST.getFirstChild() : forCond_AST;
			currentAST.advanceChildToEnd();
		}
		forCond_AST = (MyCommonAST)currentAST.root;
		returnAST = forCond_AST;
	}
	
	public final void forIter() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST forIter_AST = null;
		
		{
		switch ( LA(1)) {
		case LITERAL_void:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_short:
		case LITERAL_int:
		case LITERAL_float:
		case LITERAL_long:
		case LITERAL_double:
		case IDENT:
		case LPAREN:
		case LITERAL_this:
		case LITERAL_super:
		case PLUS:
		case MINUS:
		case INC:
		case DEC:
		case BNOT:
		case LNOT:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case NUM_INT:
		case CHAR_LITERAL:
		case STRING_LITERAL:
		case NUM_FLOAT:
		case NUM_LONG:
		case NUM_DOUBLE:
		{
			expressionList();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			break;
		}
		case RPAREN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		if ( inputState.guessing==0 ) {
			forIter_AST = (MyCommonAST)currentAST.root;
			forIter_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(FOR_ITERATOR,"FOR_ITERATOR")).add(forIter_AST));
			currentAST.root = forIter_AST;
			currentAST.child = forIter_AST!=null &&forIter_AST.getFirstChild()!=null ?
				forIter_AST.getFirstChild() : forIter_AST;
			currentAST.advanceChildToEnd();
		}
		forIter_AST = (MyCommonAST)currentAST.root;
		returnAST = forIter_AST;
	}
	
	public final void casesGroup() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST casesGroup_AST = null;
		
		{
		int _cnt102=0;
		_loop102:
		do {
			if ((LA(1)==LITERAL_case||LA(1)==LITERAL_default) && (_tokenSet_23.member(LA(2)))) {
				aCase();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				if ( _cnt102>=1 ) { break _loop102; } else {throw new NoViableAltException(LT(1), getFilename());}
			}
			
			_cnt102++;
		} while (true);
		}
		caseSList();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		if ( inputState.guessing==0 ) {
			casesGroup_AST = (MyCommonAST)currentAST.root;
			casesGroup_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(CASE_GROUP,"CASE_GROUP")).add(casesGroup_AST));
			currentAST.root = casesGroup_AST;
			currentAST.child = casesGroup_AST!=null &&casesGroup_AST.getFirstChild()!=null ?
				casesGroup_AST.getFirstChild() : casesGroup_AST;
			currentAST.advanceChildToEnd();
		}
		casesGroup_AST = (MyCommonAST)currentAST.root;
		returnAST = casesGroup_AST;
	}
	
	public final void tryBlock() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST tryBlock_AST = null;
		Token  t = null;
		MyCommonAST t_AST = null;
		Token  c = null;
		MyCommonAST c_AST = null;
		Token  f = null;
		MyCommonAST f_AST = null;
		
		final MyCommonAST[] stmtBraces = new MyCommonAST[2];
		final MethodSignature ignoreMS = new MethodSignature();
		
		
		t = LT(1);
		if (inputState.guessing==0) {
			t_AST = (MyCommonAST)astFactory.create(t);
			astFactory.makeASTRoot(currentAST, t_AST);
		}
		match(LITERAL_try);
		compoundStatement(stmtBraces);
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		if ( inputState.guessing==0 ) {
			
			ver.verifyWSAroundBegin(t.getLine(), t.getColumn(), t.getText());
			ver.verifyLCurlyOther(t.getLine(), stmtBraces[0]);
			
		}
		{
		_loop118:
		do {
			if ((LA(1)==LITERAL_catch)) {
				c = LT(1);
				if (inputState.guessing==0) {
					c_AST = (MyCommonAST)astFactory.create(c);
					astFactory.makeASTRoot(currentAST, c_AST);
				}
				match(LITERAL_catch);
				if ( inputState.guessing==0 ) {
					ver.verifyRCurly(stmtBraces[1], c.getLine());
				}
				MyCommonAST tmp101_AST = null;
				tmp101_AST = (MyCommonAST)astFactory.create(LT(1));
				match(LPAREN);
				parameterDeclaration(ignoreMS);
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
				MyCommonAST tmp102_AST = null;
				tmp102_AST = (MyCommonAST)astFactory.create(LT(1));
				match(RPAREN);
				compoundStatement(stmtBraces);
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
				if ( inputState.guessing==0 ) {
					
					ver.verifyWSAroundBegin(
					c.getLine(), c.getColumn(), c.getText());
					ver.verifyLCurlyOther(c.getLine(), stmtBraces[0]);
					
				}
			}
			else {
				break _loop118;
			}
			
		} while (true);
		}
		{
		switch ( LA(1)) {
		case LITERAL_finally:
		{
			f = LT(1);
			if (inputState.guessing==0) {
				f_AST = (MyCommonAST)astFactory.create(f);
				astFactory.makeASTRoot(currentAST, f_AST);
			}
			match(LITERAL_finally);
			if ( inputState.guessing==0 ) {
				ver.verifyRCurly(stmtBraces[1], f.getLine());
			}
			compoundStatement(stmtBraces);
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			if ( inputState.guessing==0 ) {
				ver.verifyLCurlyOther(f.getLine(), stmtBraces[0]);
			}
			break;
		}
		case FINAL:
		case ABSTRACT:
		case STRICTFP:
		case SEMI:
		case LITERAL_void:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_short:
		case LITERAL_int:
		case LITERAL_float:
		case LITERAL_long:
		case LITERAL_double:
		case IDENT:
		case LITERAL_private:
		case LITERAL_public:
		case LITERAL_protected:
		case LITERAL_static:
		case LITERAL_transient:
		case LITERAL_native:
		case LITERAL_threadsafe:
		case LITERAL_synchronized:
		case LITERAL_volatile:
		case LITERAL_class:
		case LCURLY:
		case RCURLY:
		case LPAREN:
		case LITERAL_this:
		case LITERAL_super:
		case LITERAL_if:
		case LITERAL_else:
		case LITERAL_for:
		case LITERAL_while:
		case LITERAL_do:
		case LITERAL_break:
		case LITERAL_continue:
		case LITERAL_return:
		case LITERAL_switch:
		case LITERAL_throw:
		case LITERAL_case:
		case LITERAL_default:
		case LITERAL_try:
		case PLUS:
		case MINUS:
		case INC:
		case DEC:
		case BNOT:
		case LNOT:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case NUM_INT:
		case CHAR_LITERAL:
		case STRING_LITERAL:
		case NUM_FLOAT:
		case NUM_LONG:
		case NUM_DOUBLE:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		tryBlock_AST = (MyCommonAST)currentAST.root;
		returnAST = tryBlock_AST;
	}
	
	public final void aCase() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST aCase_AST = null;
		
		{
		switch ( LA(1)) {
		case LITERAL_case:
		{
			MyCommonAST tmp103_AST = null;
			if (inputState.guessing==0) {
				tmp103_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp103_AST);
			}
			match(LITERAL_case);
			expression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			break;
		}
		case LITERAL_default:
		{
			MyCommonAST tmp104_AST = null;
			if (inputState.guessing==0) {
				tmp104_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp104_AST);
			}
			match(LITERAL_default);
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		MyCommonAST tmp105_AST = null;
		tmp105_AST = (MyCommonAST)astFactory.create(LT(1));
		match(COLON);
		aCase_AST = (MyCommonAST)currentAST.root;
		returnAST = aCase_AST;
	}
	
	public final void caseSList() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST caseSList_AST = null;
		
		{
		_loop107:
		do {
			if ((_tokenSet_12.member(LA(1)))) {
				statement(sIgnoreType, sIgnoreAST);
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				break _loop107;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			caseSList_AST = (MyCommonAST)currentAST.root;
			caseSList_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(SLIST,"SLIST")).add(caseSList_AST));
			currentAST.root = caseSList_AST;
			currentAST.child = caseSList_AST!=null &&caseSList_AST.getFirstChild()!=null ?
				caseSList_AST.getFirstChild() : caseSList_AST;
			currentAST.advanceChildToEnd();
		}
		caseSList_AST = (MyCommonAST)currentAST.root;
		returnAST = caseSList_AST;
	}
	
	public final void expressionList() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST expressionList_AST = null;
		
		expression();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		_loop123:
		do {
			if ((LA(1)==COMMA)) {
				MyCommonAST tmp106_AST = null;
				tmp106_AST = (MyCommonAST)astFactory.create(LT(1));
				match(COMMA);
				expression();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				break _loop123;
			}
			
		} while (true);
		}
		if ( inputState.guessing==0 ) {
			expressionList_AST = (MyCommonAST)currentAST.root;
			expressionList_AST = (MyCommonAST)astFactory.make( (new ASTArray(2)).add((MyCommonAST)astFactory.create(ELIST,"ELIST")).add(expressionList_AST));
			currentAST.root = expressionList_AST;
			currentAST.child = expressionList_AST!=null &&expressionList_AST.getFirstChild()!=null ?
				expressionList_AST.getFirstChild() : expressionList_AST;
			currentAST.advanceChildToEnd();
		}
		expressionList_AST = (MyCommonAST)currentAST.root;
		returnAST = expressionList_AST;
	}
	
	public final void assignmentExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST assignmentExpression_AST = null;
		
		conditionalExpression();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		switch ( LA(1)) {
		case ASSIGN:
		case PLUS_ASSIGN:
		case MINUS_ASSIGN:
		case STAR_ASSIGN:
		case DIV_ASSIGN:
		case MOD_ASSIGN:
		case SR_ASSIGN:
		case BSR_ASSIGN:
		case SL_ASSIGN:
		case BAND_ASSIGN:
		case BXOR_ASSIGN:
		case BOR_ASSIGN:
		{
			{
			switch ( LA(1)) {
			case ASSIGN:
			{
				MyCommonAST tmp107_AST = null;
				if (inputState.guessing==0) {
					tmp107_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp107_AST);
				}
				match(ASSIGN);
				break;
			}
			case PLUS_ASSIGN:
			{
				MyCommonAST tmp108_AST = null;
				if (inputState.guessing==0) {
					tmp108_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp108_AST);
				}
				match(PLUS_ASSIGN);
				break;
			}
			case MINUS_ASSIGN:
			{
				MyCommonAST tmp109_AST = null;
				if (inputState.guessing==0) {
					tmp109_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp109_AST);
				}
				match(MINUS_ASSIGN);
				break;
			}
			case STAR_ASSIGN:
			{
				MyCommonAST tmp110_AST = null;
				if (inputState.guessing==0) {
					tmp110_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp110_AST);
				}
				match(STAR_ASSIGN);
				break;
			}
			case DIV_ASSIGN:
			{
				MyCommonAST tmp111_AST = null;
				if (inputState.guessing==0) {
					tmp111_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp111_AST);
				}
				match(DIV_ASSIGN);
				break;
			}
			case MOD_ASSIGN:
			{
				MyCommonAST tmp112_AST = null;
				if (inputState.guessing==0) {
					tmp112_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp112_AST);
				}
				match(MOD_ASSIGN);
				break;
			}
			case SR_ASSIGN:
			{
				MyCommonAST tmp113_AST = null;
				if (inputState.guessing==0) {
					tmp113_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp113_AST);
				}
				match(SR_ASSIGN);
				break;
			}
			case BSR_ASSIGN:
			{
				MyCommonAST tmp114_AST = null;
				if (inputState.guessing==0) {
					tmp114_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp114_AST);
				}
				match(BSR_ASSIGN);
				break;
			}
			case SL_ASSIGN:
			{
				MyCommonAST tmp115_AST = null;
				if (inputState.guessing==0) {
					tmp115_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp115_AST);
				}
				match(SL_ASSIGN);
				break;
			}
			case BAND_ASSIGN:
			{
				MyCommonAST tmp116_AST = null;
				if (inputState.guessing==0) {
					tmp116_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp116_AST);
				}
				match(BAND_ASSIGN);
				break;
			}
			case BXOR_ASSIGN:
			{
				MyCommonAST tmp117_AST = null;
				if (inputState.guessing==0) {
					tmp117_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp117_AST);
				}
				match(BXOR_ASSIGN);
				break;
			}
			case BOR_ASSIGN:
			{
				MyCommonAST tmp118_AST = null;
				if (inputState.guessing==0) {
					tmp118_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp118_AST);
				}
				match(BOR_ASSIGN);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			assignmentExpression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			break;
		}
		case SEMI:
		case RBRACK:
		case RCURLY:
		case COMMA:
		case RPAREN:
		case COLON:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		assignmentExpression_AST = (MyCommonAST)currentAST.root;
		returnAST = assignmentExpression_AST;
	}
	
	public final void conditionalExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST conditionalExpression_AST = null;
		Token  c = null;
		MyCommonAST c_AST = null;
		
		logicalOrExpression();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		switch ( LA(1)) {
		case QUESTION:
		{
			MyCommonAST tmp119_AST = null;
			if (inputState.guessing==0) {
				tmp119_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp119_AST);
			}
			match(QUESTION);
			assignmentExpression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			c = LT(1);
			if (inputState.guessing==0) {
				c_AST = (MyCommonAST)astFactory.create(c);
				astFactory.addASTChild(currentAST, c_AST);
			}
			match(COLON);
			if ( inputState.guessing==0 ) {
				ver.verifyWSAroundBegin(c.getLine(), c.getColumn(), c.getText());
			}
			conditionalExpression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			break;
		}
		case SEMI:
		case RBRACK:
		case RCURLY:
		case COMMA:
		case RPAREN:
		case ASSIGN:
		case COLON:
		case PLUS_ASSIGN:
		case MINUS_ASSIGN:
		case STAR_ASSIGN:
		case DIV_ASSIGN:
		case MOD_ASSIGN:
		case SR_ASSIGN:
		case BSR_ASSIGN:
		case SL_ASSIGN:
		case BAND_ASSIGN:
		case BXOR_ASSIGN:
		case BOR_ASSIGN:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		conditionalExpression_AST = (MyCommonAST)currentAST.root;
		returnAST = conditionalExpression_AST;
	}
	
	public final void logicalOrExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST logicalOrExpression_AST = null;
		
		logicalAndExpression();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		_loop131:
		do {
			if ((LA(1)==LOR)) {
				MyCommonAST tmp120_AST = null;
				if (inputState.guessing==0) {
					tmp120_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp120_AST);
				}
				match(LOR);
				logicalAndExpression();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				break _loop131;
			}
			
		} while (true);
		}
		logicalOrExpression_AST = (MyCommonAST)currentAST.root;
		returnAST = logicalOrExpression_AST;
	}
	
	public final void logicalAndExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST logicalAndExpression_AST = null;
		
		inclusiveOrExpression();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		_loop134:
		do {
			if ((LA(1)==LAND)) {
				MyCommonAST tmp121_AST = null;
				if (inputState.guessing==0) {
					tmp121_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp121_AST);
				}
				match(LAND);
				inclusiveOrExpression();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				break _loop134;
			}
			
		} while (true);
		}
		logicalAndExpression_AST = (MyCommonAST)currentAST.root;
		returnAST = logicalAndExpression_AST;
	}
	
	public final void inclusiveOrExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST inclusiveOrExpression_AST = null;
		
		exclusiveOrExpression();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		_loop137:
		do {
			if ((LA(1)==BOR)) {
				MyCommonAST tmp122_AST = null;
				if (inputState.guessing==0) {
					tmp122_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp122_AST);
				}
				match(BOR);
				exclusiveOrExpression();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				break _loop137;
			}
			
		} while (true);
		}
		inclusiveOrExpression_AST = (MyCommonAST)currentAST.root;
		returnAST = inclusiveOrExpression_AST;
	}
	
	public final void exclusiveOrExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST exclusiveOrExpression_AST = null;
		
		andExpression();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		_loop140:
		do {
			if ((LA(1)==BXOR)) {
				MyCommonAST tmp123_AST = null;
				if (inputState.guessing==0) {
					tmp123_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp123_AST);
				}
				match(BXOR);
				andExpression();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				break _loop140;
			}
			
		} while (true);
		}
		exclusiveOrExpression_AST = (MyCommonAST)currentAST.root;
		returnAST = exclusiveOrExpression_AST;
	}
	
	public final void andExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST andExpression_AST = null;
		
		equalityExpression();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		_loop143:
		do {
			if ((LA(1)==BAND)) {
				MyCommonAST tmp124_AST = null;
				if (inputState.guessing==0) {
					tmp124_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp124_AST);
				}
				match(BAND);
				equalityExpression();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				break _loop143;
			}
			
		} while (true);
		}
		andExpression_AST = (MyCommonAST)currentAST.root;
		returnAST = andExpression_AST;
	}
	
	public final void equalityExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST equalityExpression_AST = null;
		
		relationalExpression();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		_loop147:
		do {
			if ((LA(1)==NOT_EQUAL||LA(1)==EQUAL)) {
				{
				switch ( LA(1)) {
				case NOT_EQUAL:
				{
					MyCommonAST tmp125_AST = null;
					if (inputState.guessing==0) {
						tmp125_AST = (MyCommonAST)astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp125_AST);
					}
					match(NOT_EQUAL);
					break;
				}
				case EQUAL:
				{
					MyCommonAST tmp126_AST = null;
					if (inputState.guessing==0) {
						tmp126_AST = (MyCommonAST)astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp126_AST);
					}
					match(EQUAL);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				relationalExpression();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				break _loop147;
			}
			
		} while (true);
		}
		equalityExpression_AST = (MyCommonAST)currentAST.root;
		returnAST = equalityExpression_AST;
	}
	
	public final void relationalExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST relationalExpression_AST = null;
		
		shiftExpression();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		switch ( LA(1)) {
		case SEMI:
		case RBRACK:
		case RCURLY:
		case COMMA:
		case RPAREN:
		case ASSIGN:
		case COLON:
		case PLUS_ASSIGN:
		case MINUS_ASSIGN:
		case STAR_ASSIGN:
		case DIV_ASSIGN:
		case MOD_ASSIGN:
		case SR_ASSIGN:
		case BSR_ASSIGN:
		case SL_ASSIGN:
		case BAND_ASSIGN:
		case BXOR_ASSIGN:
		case BOR_ASSIGN:
		case QUESTION:
		case LOR:
		case LAND:
		case BOR:
		case BXOR:
		case BAND:
		case NOT_EQUAL:
		case EQUAL:
		case LT:
		case GT:
		case LE:
		case GE:
		{
			{
			_loop152:
			do {
				if (((LA(1) >= LT && LA(1) <= GE))) {
					{
					switch ( LA(1)) {
					case LT:
					{
						MyCommonAST tmp127_AST = null;
						if (inputState.guessing==0) {
							tmp127_AST = (MyCommonAST)astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp127_AST);
						}
						match(LT);
						break;
					}
					case GT:
					{
						MyCommonAST tmp128_AST = null;
						if (inputState.guessing==0) {
							tmp128_AST = (MyCommonAST)astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp128_AST);
						}
						match(GT);
						break;
					}
					case LE:
					{
						MyCommonAST tmp129_AST = null;
						if (inputState.guessing==0) {
							tmp129_AST = (MyCommonAST)astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp129_AST);
						}
						match(LE);
						break;
					}
					case GE:
					{
						MyCommonAST tmp130_AST = null;
						if (inputState.guessing==0) {
							tmp130_AST = (MyCommonAST)astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp130_AST);
						}
						match(GE);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					shiftExpression();
					if (inputState.guessing==0) {
						astFactory.addASTChild(currentAST, returnAST);
					}
				}
				else {
					break _loop152;
				}
				
			} while (true);
			}
			break;
		}
		case LITERAL_instanceof:
		{
			MyCommonAST tmp131_AST = null;
			if (inputState.guessing==0) {
				tmp131_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp131_AST);
			}
			match(LITERAL_instanceof);
			typeSpec(true);
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		relationalExpression_AST = (MyCommonAST)currentAST.root;
		returnAST = relationalExpression_AST;
	}
	
	public final void shiftExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST shiftExpression_AST = null;
		
		additiveExpression();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		_loop156:
		do {
			if (((LA(1) >= SL && LA(1) <= BSR))) {
				{
				switch ( LA(1)) {
				case SL:
				{
					MyCommonAST tmp132_AST = null;
					if (inputState.guessing==0) {
						tmp132_AST = (MyCommonAST)astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp132_AST);
					}
					match(SL);
					break;
				}
				case SR:
				{
					MyCommonAST tmp133_AST = null;
					if (inputState.guessing==0) {
						tmp133_AST = (MyCommonAST)astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp133_AST);
					}
					match(SR);
					break;
				}
				case BSR:
				{
					MyCommonAST tmp134_AST = null;
					if (inputState.guessing==0) {
						tmp134_AST = (MyCommonAST)astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp134_AST);
					}
					match(BSR);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				additiveExpression();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				break _loop156;
			}
			
		} while (true);
		}
		shiftExpression_AST = (MyCommonAST)currentAST.root;
		returnAST = shiftExpression_AST;
	}
	
	public final void additiveExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST additiveExpression_AST = null;
		Token  p = null;
		MyCommonAST p_AST = null;
		Token  m = null;
		MyCommonAST m_AST = null;
		
		multiplicativeExpression();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		_loop160:
		do {
			if ((LA(1)==PLUS||LA(1)==MINUS)) {
				{
				switch ( LA(1)) {
				case PLUS:
				{
					p = LT(1);
					if (inputState.guessing==0) {
						p_AST = (MyCommonAST)astFactory.create(p);
						astFactory.makeASTRoot(currentAST, p_AST);
					}
					match(PLUS);
					if ( inputState.guessing==0 ) {
						ver.verifyWSAroundBegin(p.getLine(), p.getColumn(), p.getText());
					}
					break;
				}
				case MINUS:
				{
					m = LT(1);
					if (inputState.guessing==0) {
						m_AST = (MyCommonAST)astFactory.create(m);
						astFactory.makeASTRoot(currentAST, m_AST);
					}
					match(MINUS);
					if ( inputState.guessing==0 ) {
						ver.verifyWSAroundBegin(m.getLine(), m.getColumn(), m.getText());
					}
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				multiplicativeExpression();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				break _loop160;
			}
			
		} while (true);
		}
		additiveExpression_AST = (MyCommonAST)currentAST.root;
		returnAST = additiveExpression_AST;
	}
	
	public final void multiplicativeExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST multiplicativeExpression_AST = null;
		Token  s = null;
		MyCommonAST s_AST = null;
		
		unaryExpression();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		_loop164:
		do {
			if ((_tokenSet_24.member(LA(1)))) {
				{
				switch ( LA(1)) {
				case STAR:
				{
					s = LT(1);
					if (inputState.guessing==0) {
						s_AST = (MyCommonAST)astFactory.create(s);
						astFactory.makeASTRoot(currentAST, s_AST);
					}
					match(STAR);
					if ( inputState.guessing==0 ) {
						ver.verifyWSAroundBegin(s.getLine(), s.getColumn(), s.getText());
					}
					break;
				}
				case DIV:
				{
					MyCommonAST tmp135_AST = null;
					if (inputState.guessing==0) {
						tmp135_AST = (MyCommonAST)astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp135_AST);
					}
					match(DIV);
					break;
				}
				case MOD:
				{
					MyCommonAST tmp136_AST = null;
					if (inputState.guessing==0) {
						tmp136_AST = (MyCommonAST)astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp136_AST);
					}
					match(MOD);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				unaryExpression();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				break _loop164;
			}
			
		} while (true);
		}
		multiplicativeExpression_AST = (MyCommonAST)currentAST.root;
		returnAST = multiplicativeExpression_AST;
	}
	
	public final void unaryExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST unaryExpression_AST = null;
		
		switch ( LA(1)) {
		case INC:
		{
			MyCommonAST tmp137_AST = null;
			if (inputState.guessing==0) {
				tmp137_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp137_AST);
			}
			match(INC);
			unaryExpression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			if ( inputState.guessing==0 ) {
				ver.verifyNoWSAfter(tmp137_AST);
			}
			unaryExpression_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case DEC:
		{
			MyCommonAST tmp138_AST = null;
			if (inputState.guessing==0) {
				tmp138_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp138_AST);
			}
			match(DEC);
			unaryExpression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			if ( inputState.guessing==0 ) {
				ver.verifyNoWSAfter(tmp138_AST);
			}
			unaryExpression_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case MINUS:
		{
			MyCommonAST tmp139_AST = null;
			if (inputState.guessing==0) {
				tmp139_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp139_AST);
			}
			match(MINUS);
			if ( inputState.guessing==0 ) {
				tmp139_AST.setType(UNARY_MINUS); ver.verifyNoWSAfter(tmp139_AST);
			}
			unaryExpression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			unaryExpression_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case PLUS:
		{
			MyCommonAST tmp140_AST = null;
			if (inputState.guessing==0) {
				tmp140_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp140_AST);
			}
			match(PLUS);
			if ( inputState.guessing==0 ) {
				tmp140_AST.setType(UNARY_PLUS); ver.verifyNoWSAfter(tmp140_AST);
			}
			unaryExpression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			unaryExpression_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_void:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_short:
		case LITERAL_int:
		case LITERAL_float:
		case LITERAL_long:
		case LITERAL_double:
		case IDENT:
		case LPAREN:
		case LITERAL_this:
		case LITERAL_super:
		case BNOT:
		case LNOT:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case NUM_INT:
		case CHAR_LITERAL:
		case STRING_LITERAL:
		case NUM_FLOAT:
		case NUM_LONG:
		case NUM_DOUBLE:
		{
			unaryExpressionNotPlusMinus();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			unaryExpression_AST = (MyCommonAST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = unaryExpression_AST;
	}
	
	public final void unaryExpressionNotPlusMinus() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST unaryExpressionNotPlusMinus_AST = null;
		Token  lpb = null;
		MyCommonAST lpb_AST = null;
		Token  rpb = null;
		MyCommonAST rpb_AST = null;
		Token  lp = null;
		MyCommonAST lp_AST = null;
		Token  rpb2 = null;
		MyCommonAST rpb2_AST = null;
		
		switch ( LA(1)) {
		case BNOT:
		{
			MyCommonAST tmp141_AST = null;
			if (inputState.guessing==0) {
				tmp141_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp141_AST);
			}
			match(BNOT);
			unaryExpression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			if ( inputState.guessing==0 ) {
				ver.verifyNoWSAfter(tmp141_AST);
			}
			unaryExpressionNotPlusMinus_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LNOT:
		{
			MyCommonAST tmp142_AST = null;
			if (inputState.guessing==0) {
				tmp142_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp142_AST);
			}
			match(LNOT);
			unaryExpression();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			if ( inputState.guessing==0 ) {
				ver.verifyNoWSAfter(tmp142_AST);
			}
			unaryExpressionNotPlusMinus_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case LITERAL_void:
		case LITERAL_boolean:
		case LITERAL_byte:
		case LITERAL_char:
		case LITERAL_short:
		case LITERAL_int:
		case LITERAL_float:
		case LITERAL_long:
		case LITERAL_double:
		case IDENT:
		case LPAREN:
		case LITERAL_this:
		case LITERAL_super:
		case LITERAL_true:
		case LITERAL_false:
		case LITERAL_null:
		case LITERAL_new:
		case NUM_INT:
		case CHAR_LITERAL:
		case STRING_LITERAL:
		case NUM_FLOAT:
		case NUM_LONG:
		case NUM_DOUBLE:
		{
			{
			if ((LA(1)==LPAREN) && ((LA(2) >= LITERAL_void && LA(2) <= LITERAL_double))) {
				lpb = LT(1);
				if (inputState.guessing==0) {
					lpb_AST = (MyCommonAST)astFactory.create(lpb);
					astFactory.makeASTRoot(currentAST, lpb_AST);
				}
				match(LPAREN);
				if ( inputState.guessing==0 ) {
					lpb_AST.setType(TYPECAST);
				}
				builtInTypeSpec(true);
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
				rpb = LT(1);
				if (inputState.guessing==0) {
					rpb_AST = (MyCommonAST)astFactory.create(rpb);
				}
				match(RPAREN);
				if ( inputState.guessing==0 ) {
					ver.verifyWSAfter(rpb.getLine(), rpb.getColumn(), MyToken.CAST);
				}
				unaryExpression();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
			}
			else {
				boolean synPredMatched169 = false;
				if (((LA(1)==LPAREN) && (LA(2)==IDENT))) {
					int _m169 = mark();
					synPredMatched169 = true;
					inputState.guessing++;
					try {
						{
						match(LPAREN);
						classTypeSpec(true);
						match(RPAREN);
						unaryExpressionNotPlusMinus();
						}
					}
					catch (RecognitionException pe) {
						synPredMatched169 = false;
					}
					rewind(_m169);
					inputState.guessing--;
				}
				if ( synPredMatched169 ) {
					lp = LT(1);
					if (inputState.guessing==0) {
						lp_AST = (MyCommonAST)astFactory.create(lp);
						astFactory.makeASTRoot(currentAST, lp_AST);
					}
					match(LPAREN);
					if ( inputState.guessing==0 ) {
						lp_AST.setType(TYPECAST);
					}
					classTypeSpec(true);
					if (inputState.guessing==0) {
						astFactory.addASTChild(currentAST, returnAST);
					}
					rpb2 = LT(1);
					if (inputState.guessing==0) {
						rpb2_AST = (MyCommonAST)astFactory.create(rpb2);
					}
					match(RPAREN);
					if ( inputState.guessing==0 ) {
						ver.verifyWSAfter(rpb2.getLine(), rpb2.getColumn(), MyToken.CAST);
					}
					unaryExpressionNotPlusMinus();
					if (inputState.guessing==0) {
						astFactory.addASTChild(currentAST, returnAST);
					}
				}
				else if ((_tokenSet_8.member(LA(1))) && (_tokenSet_25.member(LA(2)))) {
					postfixExpression();
					if (inputState.guessing==0) {
						astFactory.addASTChild(currentAST, returnAST);
					}
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				unaryExpressionNotPlusMinus_AST = (MyCommonAST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			returnAST = unaryExpressionNotPlusMinus_AST;
		}
		
	public final void postfixExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST postfixExpression_AST = null;
		Token  lbc = null;
		MyCommonAST lbc_AST = null;
		Token  lb = null;
		MyCommonAST lb_AST = null;
		Token  lp = null;
		MyCommonAST lp_AST = null;
		Token  in = null;
		MyCommonAST in_AST = null;
		Token  de = null;
		MyCommonAST de_AST = null;
		
		primaryExpression();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		_loop175:
		do {
			switch ( LA(1)) {
			case DOT:
			{
				MyCommonAST tmp143_AST = null;
				if (inputState.guessing==0) {
					tmp143_AST = (MyCommonAST)astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp143_AST);
				}
				match(DOT);
				if ( inputState.guessing==0 ) {
					ver.verifyDot(tmp143_AST);
				}
				{
				switch ( LA(1)) {
				case IDENT:
				{
					MyCommonAST tmp144_AST = null;
					if (inputState.guessing==0) {
						tmp144_AST = (MyCommonAST)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp144_AST);
					}
					match(IDENT);
					if ( inputState.guessing==0 ) {
						ver.reportReference(sFirstIdent);
					}
					break;
				}
				case LITERAL_this:
				{
					MyCommonAST tmp145_AST = null;
					if (inputState.guessing==0) {
						tmp145_AST = (MyCommonAST)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp145_AST);
					}
					match(LITERAL_this);
					break;
				}
				case LITERAL_class:
				{
					MyCommonAST tmp146_AST = null;
					if (inputState.guessing==0) {
						tmp146_AST = (MyCommonAST)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp146_AST);
					}
					match(LITERAL_class);
					if ( inputState.guessing==0 ) {
						ver.reportReference(sFirstIdent);
					}
					break;
				}
				case LITERAL_new:
				{
					newExpression();
					if (inputState.guessing==0) {
						astFactory.addASTChild(currentAST, returnAST);
					}
					break;
				}
				case LITERAL_super:
				{
					MyCommonAST tmp147_AST = null;
					if (inputState.guessing==0) {
						tmp147_AST = (MyCommonAST)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp147_AST);
					}
					match(LITERAL_super);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				break;
			}
			case LPAREN:
			{
				lp = LT(1);
				if (inputState.guessing==0) {
					lp_AST = (MyCommonAST)astFactory.create(lp);
					astFactory.makeASTRoot(currentAST, lp_AST);
				}
				match(LPAREN);
				if ( inputState.guessing==0 ) {
					lp_AST.setType(METHOD_CALL);
				}
				argList();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
				MyCommonAST tmp148_AST = null;
				tmp148_AST = (MyCommonAST)astFactory.create(LT(1));
				match(RPAREN);
				break;
			}
			default:
				if ((LA(1)==LBRACK) && (LA(2)==RBRACK)) {
					{
					int _cnt174=0;
					_loop174:
					do {
						if ((LA(1)==LBRACK)) {
							lbc = LT(1);
							if (inputState.guessing==0) {
								lbc_AST = (MyCommonAST)astFactory.create(lbc);
								astFactory.makeASTRoot(currentAST, lbc_AST);
							}
							match(LBRACK);
							if ( inputState.guessing==0 ) {
								lbc_AST.setType(ARRAY_DECLARATOR);
							}
							MyCommonAST tmp149_AST = null;
							tmp149_AST = (MyCommonAST)astFactory.create(LT(1));
							match(RBRACK);
						}
						else {
							if ( _cnt174>=1 ) { break _loop174; } else {throw new NoViableAltException(LT(1), getFilename());}
						}
						
						_cnt174++;
					} while (true);
					}
					MyCommonAST tmp150_AST = null;
					if (inputState.guessing==0) {
						tmp150_AST = (MyCommonAST)astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp150_AST);
					}
					match(DOT);
					MyCommonAST tmp151_AST = null;
					if (inputState.guessing==0) {
						tmp151_AST = (MyCommonAST)astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp151_AST);
					}
					match(LITERAL_class);
					if ( inputState.guessing==0 ) {
						ver.verifyDot(tmp150_AST);
					}
				}
				else if ((LA(1)==LBRACK) && (_tokenSet_18.member(LA(2)))) {
					lb = LT(1);
					if (inputState.guessing==0) {
						lb_AST = (MyCommonAST)astFactory.create(lb);
						astFactory.makeASTRoot(currentAST, lb_AST);
					}
					match(LBRACK);
					if ( inputState.guessing==0 ) {
						lb_AST.setType(INDEX_OP);
					}
					expression();
					if (inputState.guessing==0) {
						astFactory.addASTChild(currentAST, returnAST);
					}
					MyCommonAST tmp152_AST = null;
					tmp152_AST = (MyCommonAST)astFactory.create(LT(1));
					match(RBRACK);
				}
			else {
				break _loop175;
			}
			}
		} while (true);
		}
		{
		switch ( LA(1)) {
		case INC:
		{
			in = LT(1);
			if (inputState.guessing==0) {
				in_AST = (MyCommonAST)astFactory.create(in);
				astFactory.makeASTRoot(currentAST, in_AST);
			}
			match(INC);
			if ( inputState.guessing==0 ) {
				in_AST.setType(POST_INC); ver.verifyNoWSBefore(in_AST);
			}
			break;
		}
		case DEC:
		{
			de = LT(1);
			if (inputState.guessing==0) {
				de_AST = (MyCommonAST)astFactory.create(de);
				astFactory.makeASTRoot(currentAST, de_AST);
			}
			match(DEC);
			if ( inputState.guessing==0 ) {
				de_AST.setType(POST_DEC); ver.verifyNoWSBefore(de_AST);
			}
			break;
		}
		case SEMI:
		case RBRACK:
		case STAR:
		case RCURLY:
		case COMMA:
		case RPAREN:
		case ASSIGN:
		case COLON:
		case PLUS_ASSIGN:
		case MINUS_ASSIGN:
		case STAR_ASSIGN:
		case DIV_ASSIGN:
		case MOD_ASSIGN:
		case SR_ASSIGN:
		case BSR_ASSIGN:
		case SL_ASSIGN:
		case BAND_ASSIGN:
		case BXOR_ASSIGN:
		case BOR_ASSIGN:
		case QUESTION:
		case LOR:
		case LAND:
		case BOR:
		case BXOR:
		case BAND:
		case NOT_EQUAL:
		case EQUAL:
		case LT:
		case GT:
		case LE:
		case GE:
		case LITERAL_instanceof:
		case SL:
		case SR:
		case BSR:
		case PLUS:
		case MINUS:
		case DIV:
		case MOD:
		{
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		postfixExpression_AST = (MyCommonAST)currentAST.root;
		returnAST = postfixExpression_AST;
	}
	
/** object instantiation.
 *  Trees are built as illustrated by the following input/tree pairs:
 *
 *  new T()
 *
 *  new
 *   |
 *   T --  ELIST
 *           |
 *          arg1 -- arg2 -- .. -- argn
 *
 *  new int[]
 *
 *  new
 *   |
 *  int -- ARRAY_DECLARATOR
 *
 *  new int[] {1,2}
 *
 *  new
 *   |
 *  int -- ARRAY_DECLARATOR -- ARRAY_INIT
 *                                  |
 *                                EXPR -- EXPR
 *                                  |      |
 *                                  1      2
 *
 *  new int[3]
 *  new
 *   |
 *  int -- ARRAY_DECLARATOR
 *                |
 *              EXPR
 *                |
 *                3
 *
 *  new int[1][2]
 *
 *  new
 *   |
 *  int -- ARRAY_DECLARATOR
 *               |
 *         ARRAY_DECLARATOR -- EXPR
 *               |              |
 *             EXPR             1
 *               |
 *               2
 *
 */
	public final void newExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST newExpression_AST = null;
		
		MyCommonAST tmp153_AST = null;
		if (inputState.guessing==0) {
			tmp153_AST = (MyCommonAST)astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp153_AST);
		}
		match(LITERAL_new);
		type();
		if (inputState.guessing==0) {
			astFactory.addASTChild(currentAST, returnAST);
		}
		{
		switch ( LA(1)) {
		case LPAREN:
		{
			MyCommonAST tmp154_AST = null;
			tmp154_AST = (MyCommonAST)astFactory.create(LT(1));
			match(LPAREN);
			argList();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			MyCommonAST tmp155_AST = null;
			tmp155_AST = (MyCommonAST)astFactory.create(LT(1));
			match(RPAREN);
			{
			switch ( LA(1)) {
			case LCURLY:
			{
				if ( inputState.guessing==0 ) {
					ver.reportStartTypeBlock(Scope.ANONINNER, false);
				}
				classBlock(-1);
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
				if ( inputState.guessing==0 ) {
					ver.reportEndTypeBlock();
				}
				break;
			}
			case SEMI:
			case LBRACK:
			case RBRACK:
			case DOT:
			case STAR:
			case RCURLY:
			case COMMA:
			case LPAREN:
			case RPAREN:
			case ASSIGN:
			case COLON:
			case PLUS_ASSIGN:
			case MINUS_ASSIGN:
			case STAR_ASSIGN:
			case DIV_ASSIGN:
			case MOD_ASSIGN:
			case SR_ASSIGN:
			case BSR_ASSIGN:
			case SL_ASSIGN:
			case BAND_ASSIGN:
			case BXOR_ASSIGN:
			case BOR_ASSIGN:
			case QUESTION:
			case LOR:
			case LAND:
			case BOR:
			case BXOR:
			case BAND:
			case NOT_EQUAL:
			case EQUAL:
			case LT:
			case GT:
			case LE:
			case GE:
			case LITERAL_instanceof:
			case SL:
			case SR:
			case BSR:
			case PLUS:
			case MINUS:
			case DIV:
			case MOD:
			case INC:
			case DEC:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		case LBRACK:
		{
			newArrayDeclarator();
			if (inputState.guessing==0) {
				astFactory.addASTChild(currentAST, returnAST);
			}
			{
			switch ( LA(1)) {
			case LCURLY:
			{
				arrayInitializer();
				if (inputState.guessing==0) {
					astFactory.addASTChild(currentAST, returnAST);
				}
				break;
			}
			case SEMI:
			case LBRACK:
			case RBRACK:
			case DOT:
			case STAR:
			case RCURLY:
			case COMMA:
			case LPAREN:
			case RPAREN:
			case ASSIGN:
			case COLON:
			case PLUS_ASSIGN:
			case MINUS_ASSIGN:
			case STAR_ASSIGN:
			case DIV_ASSIGN:
			case MOD_ASSIGN:
			case SR_ASSIGN:
			case BSR_ASSIGN:
			case SL_ASSIGN:
			case BAND_ASSIGN:
			case BXOR_ASSIGN:
			case BOR_ASSIGN:
			case QUESTION:
			case LOR:
			case LAND:
			case BOR:
			case BXOR:
			case BAND:
			case NOT_EQUAL:
			case EQUAL:
			case LT:
			case GT:
			case LE:
			case GE:
			case LITERAL_instanceof:
			case SL:
			case SR:
			case BSR:
			case PLUS:
			case MINUS:
			case DIV:
			case MOD:
			case INC:
			case DEC:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		}
		newExpression_AST = (MyCommonAST)currentAST.root;
		returnAST = newExpression_AST;
	}
	
	public final void constant() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST constant_AST = null;
		
		switch ( LA(1)) {
		case NUM_INT:
		{
			MyCommonAST tmp156_AST = null;
			if (inputState.guessing==0) {
				tmp156_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp156_AST);
			}
			match(NUM_INT);
			constant_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case CHAR_LITERAL:
		{
			MyCommonAST tmp157_AST = null;
			if (inputState.guessing==0) {
				tmp157_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp157_AST);
			}
			match(CHAR_LITERAL);
			constant_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case STRING_LITERAL:
		{
			MyCommonAST tmp158_AST = null;
			if (inputState.guessing==0) {
				tmp158_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp158_AST);
			}
			match(STRING_LITERAL);
			constant_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case NUM_FLOAT:
		{
			MyCommonAST tmp159_AST = null;
			if (inputState.guessing==0) {
				tmp159_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp159_AST);
			}
			match(NUM_FLOAT);
			constant_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case NUM_LONG:
		{
			MyCommonAST tmp160_AST = null;
			if (inputState.guessing==0) {
				tmp160_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp160_AST);
			}
			match(NUM_LONG);
			constant_AST = (MyCommonAST)currentAST.root;
			break;
		}
		case NUM_DOUBLE:
		{
			MyCommonAST tmp161_AST = null;
			if (inputState.guessing==0) {
				tmp161_AST = (MyCommonAST)astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp161_AST);
			}
			match(NUM_DOUBLE);
			constant_AST = (MyCommonAST)currentAST.root;
			break;
		}
		default:
		{
			throw new NoViableAltException(LT(1), getFilename());
		}
		}
		returnAST = constant_AST;
	}
	
	public final void newArrayDeclarator() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		MyCommonAST newArrayDeclarator_AST = null;
		Token  lb = null;
		MyCommonAST lb_AST = null;
		
		{
		int _cnt189=0;
		_loop189:
		do {
			if ((LA(1)==LBRACK) && (_tokenSet_26.member(LA(2)))) {
				lb = LT(1);
				if (inputState.guessing==0) {
					lb_AST = (MyCommonAST)astFactory.create(lb);
					astFactory.makeASTRoot(currentAST, lb_AST);
				}
				match(LBRACK);
				if ( inputState.guessing==0 ) {
					lb_AST.setType(ARRAY_DECLARATOR);
				}
				{
				switch ( LA(1)) {
				case LITERAL_void:
				case LITERAL_boolean:
				case LITERAL_byte:
				case LITERAL_char:
				case LITERAL_short:
				case LITERAL_int:
				case LITERAL_float:
				case LITERAL_long:
				case LITERAL_double:
				case IDENT:
				case LPAREN:
				case LITERAL_this:
				case LITERAL_super:
				case PLUS:
				case MINUS:
				case INC:
				case DEC:
				case BNOT:
				case LNOT:
				case LITERAL_true:
				case LITERAL_false:
				case LITERAL_null:
				case LITERAL_new:
				case NUM_INT:
				case CHAR_LITERAL:
				case STRING_LITERAL:
				case NUM_FLOAT:
				case NUM_LONG:
				case NUM_DOUBLE:
				{
					expression();
					if (inputState.guessing==0) {
						astFactory.addASTChild(currentAST, returnAST);
					}
					break;
				}
				case RBRACK:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				MyCommonAST tmp162_AST = null;
				tmp162_AST = (MyCommonAST)astFactory.create(LT(1));
				match(RBRACK);
			}
			else {
				if ( _cnt189>=1 ) { break _loop189; } else {throw new NoViableAltException(LT(1), getFilename());}
			}
			
			_cnt189++;
		} while (true);
		}
		newArrayDeclarator_AST = (MyCommonAST)currentAST.root;
		returnAST = newArrayDeclarator_AST;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"BLOCK",
		"MODIFIERS",
		"OBJBLOCK",
		"SLIST",
		"CTOR_DEF",
		"METHOD_DEF",
		"VARIABLE_DEF",
		"INSTANCE_INIT",
		"STATIC_INIT",
		"TYPE",
		"CLASS_DEF",
		"INTERFACE_DEF",
		"PACKAGE_DEF",
		"ARRAY_DECLARATOR",
		"EXTENDS_CLAUSE",
		"IMPLEMENTS_CLAUSE",
		"PARAMETERS",
		"PARAMETER_DEF",
		"LABELED_STAT",
		"TYPECAST",
		"INDEX_OP",
		"POST_INC",
		"POST_DEC",
		"METHOD_CALL",
		"EXPR",
		"ARRAY_INIT",
		"IMPORT",
		"UNARY_MINUS",
		"UNARY_PLUS",
		"CASE_GROUP",
		"ELIST",
		"FOR_INIT",
		"FOR_CONDITION",
		"FOR_ITERATOR",
		"EMPTY_STAT",
		"\"final\"",
		"\"abstract\"",
		"\"strictfp\"",
		"SUPER_CTOR_CALL",
		"CTOR_CALL",
		"\"package\"",
		"SEMI",
		"\"import\"",
		"LBRACK",
		"RBRACK",
		"\"void\"",
		"\"boolean\"",
		"\"byte\"",
		"\"char\"",
		"\"short\"",
		"\"int\"",
		"\"float\"",
		"\"long\"",
		"\"double\"",
		"IDENT",
		"DOT",
		"STAR",
		"\"private\"",
		"\"public\"",
		"\"protected\"",
		"\"static\"",
		"\"transient\"",
		"\"native\"",
		"\"threadsafe\"",
		"\"synchronized\"",
		"\"volatile\"",
		"\"class\"",
		"\"extends\"",
		"\"interface\"",
		"LCURLY",
		"RCURLY",
		"COMMA",
		"\"implements\"",
		"LPAREN",
		"RPAREN",
		"\"this\"",
		"\"super\"",
		"ASSIGN",
		"\"throws\"",
		"COLON",
		"\"if\"",
		"\"else\"",
		"\"for\"",
		"\"while\"",
		"\"do\"",
		"\"break\"",
		"\"continue\"",
		"\"return\"",
		"\"switch\"",
		"\"throw\"",
		"\"case\"",
		"\"default\"",
		"\"try\"",
		"\"catch\"",
		"\"finally\"",
		"PLUS_ASSIGN",
		"MINUS_ASSIGN",
		"STAR_ASSIGN",
		"DIV_ASSIGN",
		"MOD_ASSIGN",
		"SR_ASSIGN",
		"BSR_ASSIGN",
		"SL_ASSIGN",
		"BAND_ASSIGN",
		"BXOR_ASSIGN",
		"BOR_ASSIGN",
		"QUESTION",
		"LOR",
		"LAND",
		"BOR",
		"BXOR",
		"BAND",
		"NOT_EQUAL",
		"EQUAL",
		"LT",
		"GT",
		"LE",
		"GE",
		"\"instanceof\"",
		"SL",
		"SR",
		"BSR",
		"PLUS",
		"MINUS",
		"DIV",
		"MOD",
		"INC",
		"DEC",
		"BNOT",
		"LNOT",
		"\"true\"",
		"\"false\"",
		"\"null\"",
		"\"new\"",
		"NUM_INT",
		"CHAR_LITERAL",
		"STRING_LITERAL",
		"NUM_FLOAT",
		"NUM_LONG",
		"NUM_DOUBLE",
		"WS",
		"SL_COMMENT",
		"ML_COMMENT",
		"ESC",
		"HEX_DIGIT",
		"VOCAB",
		"EXPONENT",
		"FLOAT_SUFFIX"
	};
	
	private static final long _tokenSet_0_data_[] = { -2305803976550907904L, 383L, 0L, 0L };
	public static final BitSet _tokenSet_0 = new BitSet(_tokenSet_0_data_);
	private static final long _tokenSet_1_data_[] = { -2305733607806730238L, 383L, 0L, 0L };
	public static final BitSet _tokenSet_1 = new BitSet(_tokenSet_1_data_);
	private static final long _tokenSet_2_data_[] = { -2305803976550907902L, 383L, 0L, 0L };
	public static final BitSet _tokenSet_2 = new BitSet(_tokenSet_2_data_);
	private static final long _tokenSet_3_data_[] = { -2305839160922996736L, 63L, 0L, 0L };
	public static final BitSet _tokenSet_3 = new BitSet(_tokenSet_3_data_);
	private static final long _tokenSet_4_data_[] = { -1729941358572994560L, 383L, 0L, 0L };
	public static final BitSet _tokenSet_4 = new BitSet(_tokenSet_4_data_);
	private static final long _tokenSet_5_data_[] = { -1153339868781215744L, 8575L, 0L, 0L };
	public static final BitSet _tokenSet_5 = new BitSet(_tokenSet_5_data_);
	private static final long _tokenSet_6_data_[] = { 864831865943490560L, 0L, 0L };
	public static final BitSet _tokenSet_6 = new BitSet(_tokenSet_6_data_);
	private static final long _tokenSet_7_data_[] = { 175921860444160L, 133120L, 0L, 0L };
	public static final BitSet _tokenSet_7 = new BitSet(_tokenSet_7_data_);
	private static final long _tokenSet_8_data_[] = { 575897802350002176L, 106496L, 65472L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_8 = new BitSet(_tokenSet_8_data_);
	private static final long _tokenSet_9_data_[] = { 1152499292141780992L, -4611686018427281408L, 65532L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_9 = new BitSet(_tokenSet_9_data_);
	private static final long _tokenSet_10_data_[] = { -1729906174200905728L, -4611686013061716353L, 65532L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_10 = new BitSet(_tokenSet_10_data_);
	private static final long _tokenSet_11_data_[] = { -383179802279936L, -28993411201L, 65535L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_11 = new BitSet(_tokenSet_11_data_);
	private static final long _tokenSet_12_data_[] = { -1729906174200905728L, -4611686013061717377L, 65532L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_12 = new BitSet(_tokenSet_12_data_);
	private static final long _tokenSet_13_data_[] = { 575897802350002176L, -4611686018427280896L, 65532L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_13 = new BitSet(_tokenSet_13_data_);
	private static final long _tokenSet_14_data_[] = { -1729906174200905728L, -4611686009838393729L, 65532L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_14 = new BitSet(_tokenSet_14_data_);
	private static final long _tokenSet_15_data_[] = { -383179802279936L, -284801L, 65535L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_15 = new BitSet(_tokenSet_15_data_);
	private static final long _tokenSet_16_data_[] = { -1729941358572994560L, 63L, 0L, 0L };
	public static final BitSet _tokenSet_16 = new BitSet(_tokenSet_16_data_);
	private static final long _tokenSet_17_data_[] = { -1153339868781215744L, 63L, 0L, 0L };
	public static final BitSet _tokenSet_17 = new BitSet(_tokenSet_17_data_);
	private static final long _tokenSet_18_data_[] = { 575897802350002176L, -4611686018427281408L, 65532L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_18 = new BitSet(_tokenSet_18_data_);
	private static final long _tokenSet_19_data_[] = { 2305455981120716800L, -34359500800L, 65535L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_19 = new BitSet(_tokenSet_19_data_);
	private static final long _tokenSet_20_data_[] = { -2305839160922996736L, 127L, 0L, 0L };
	public static final BitSet _tokenSet_20 = new BitSet(_tokenSet_20_data_);
	private static final long _tokenSet_21_data_[] = { -2017608784771284992L, 127L, 0L, 0L };
	public static final BitSet _tokenSet_21 = new BitSet(_tokenSet_21_data_);
	private static final long _tokenSet_22_data_[] = { 2305455981120716800L, -34359498752L, 65535L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_22 = new BitSet(_tokenSet_22_data_);
	private static final long _tokenSet_23_data_[] = { 575897802350002176L, -4611686018426757120L, 65532L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_23 = new BitSet(_tokenSet_23_data_);
	private static final long _tokenSet_24_data_[] = { 1152921504606846976L, 0L, 3L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_24 = new BitSet(_tokenSet_24_data_);
	private static final long _tokenSet_25_data_[] = { 2305737456097427456L, -34358957056L, 65535L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_25 = new BitSet(_tokenSet_25_data_);
	private static final long _tokenSet_26_data_[] = { 576179277326712832L, -4611686018427281408L, 65532L, 0L, 0L, 0L };
	public static final BitSet _tokenSet_26 = new BitSet(_tokenSet_26_data_);
	
	}
