header {
package com.puppycrawl.tools.checkstyle;
}
class GeneratedJava14Recognizer extends Parser;

options {
	k= 2;
	exportVocab=GeneratedJava14;
	codeGenMakeSwitchThreshold= 2;
	codeGenBitsetTestThreshold= 3;
	defaultErrorHandler= false;
	buildAST= true;
	ASTLabelType=MyCommonAST;
	importVocab=GeneratedJava;
}

{
    final Verifier ver = VerifierSingleton.getInstance();
    private static String sFirstIdent = "";
    private static final MyCommonAST[] sIgnoreAST = new MyCommonAST[2];
    private static LineText sLastIdentifier;
    private static final int[] sIgnoreType = new int[1];

    // Constants to indicate statement type. Numbers are delibrately weird
    private static int STMT_OTHER = 0;
    private static int STMT_COMPOUND = 6;
    private static int STMT_IF = 8;
}
statement[int[] aType, MyCommonAST[] aCurlies] :traditionalStatement[aType, aCurlies]
	|	assertStatement[aType, aCurlies]
	;

assertStatement[int[] aType, MyCommonAST[] aCurlies] {
    final MyModifierSet modSet = new MyModifierSet();
    final int[] stmtType = new int[1];
    final MyCommonAST[] stmtBraces = new MyCommonAST[2];
    stmtType[0] = STMT_OTHER;
}
:asrt:ASSERT^ expression ( c:COLON! expression )? SEMI!
        {
            ver.verifyWSAroundBegin(asrt.getLine(), asrt.getColumn(), asrt.getText());
            if (c != null) {
                ver.verifyWSAroundBegin(c.getLine(), c.getColumn(), c.getText());
            }
        }
	;

// inherited from grammar GeneratedJavaRecognizer
compilationUnit :// A compilation unit starts with an optional package definition
		(	packageDefinition
		|	/* nothing */
		)

		// Next we have a series of zero or more import statements
		( importDefinition )*

		// Wrapping things up with any number of class or interface
		//    definitions
		( typeDefinition )*

		EOF!
	;

// inherited from grammar GeneratedJavaRecognizer
packageDefinition 
options {
	defaultErrorHandler= true;
}
:p:"package"^ {#p.setType(PACKAGE_DEF);} identifier SEMI!
        { ver.reportPackageName(sLastIdentifier.getText()); }
	;

// inherited from grammar GeneratedJavaRecognizer
importDefinition 
options {
	defaultErrorHandler= true;
}
:i:"import"^ {#i.setType(IMPORT);} identifierStar SEMI!
	;

// inherited from grammar GeneratedJavaRecognizer
typeDefinition 
options {
	defaultErrorHandler= true;
}
{ MyModifierSet modSet = new MyModifierSet(); }
:m:modifiers[modSet]!
		( classDefinition[#m, modSet]
		| interfaceDefinition[#m, modSet]
		)
	|	SEMI!
	;

// inherited from grammar GeneratedJavaRecognizer
declaration! { MyModifierSet modSet = new MyModifierSet(); }
:m:modifiers[modSet] t:typeSpec[false] v:variableDefinitions[#m,#t, modSet]
		{#declaration = #v;}
	;

// inherited from grammar GeneratedJavaRecognizer
typeSpec[boolean addImagNode] :classTypeSpec[addImagNode]
	| builtInTypeSpec[addImagNode]
	;

// inherited from grammar GeneratedJavaRecognizer
classTypeSpec[boolean addImagNode] :identifier (lb:LBRACK^ {#lb.setType(ARRAY_DECLARATOR);} RBRACK!)*
		{
			if ( addImagNode ) {
				#classTypeSpec = #(#[TYPE,"TYPE"], #classTypeSpec);
			}
		}
	;

// inherited from grammar GeneratedJavaRecognizer
builtInTypeSpec[boolean addImagNode] :builtInType (lb:LBRACK^ {#lb.setType(ARRAY_DECLARATOR);} RBRACK!)*
		{
			if ( addImagNode ) {
				#builtInTypeSpec = #(#[TYPE,"TYPE"], #builtInTypeSpec);
			}
		}
	;

// inherited from grammar GeneratedJavaRecognizer
type :identifier
	|	builtInType
	;

// inherited from grammar GeneratedJavaRecognizer
builtInType :"void"
	|	"boolean"
	|	"byte"
	|	"char"
	|	"short"
	|	"int"
	|	"float"
	|	"long"
	|	"double"
	;

// inherited from grammar GeneratedJavaRecognizer
identifier :i1:IDENT
        {
            ver.reportReference(i1.getText());
            sLastIdentifier = new LineText(i1.getLine(), i1.getColumn(), i1.getText());
        }
        ( DOT^ i2:IDENT {ver.verifyDot(#DOT); sLastIdentifier.appendText("." + i2.getText());} )*
	;

// inherited from grammar GeneratedJavaRecognizer
identifierStar { int ln = 0; String str = ""; boolean star = false; }
:i1:IDENT {ln = i1.getLine(); str = i1.getText();}
		( DOT^ i2:IDENT {str += "." + i2.getText(); ver.verifyDot(#DOT); } )*
		( DOT^ i3:STAR {str += ".*"; star = true; ver.verifyDot(#DOT); } )?
{
 if (star) {
  ver.reportStarImport(ln, str);
 } else {
  ver.reportImport(ln, str);
 }
}
	;

// inherited from grammar GeneratedJavaRecognizer
modifiers[MyModifierSet mms] :( m:modifier {mms.addModifier(#m);} )*
		{#modifiers = #([MODIFIERS, "MODIFIERS"], #modifiers);}
	;

// inherited from grammar GeneratedJavaRecognizer
modifier :"private"
	|	"public"
	|	"protected"
	|	"static"
	|	"transient"
	|	"final"
	|	"abstract"
	|	"native"
	|	"threadsafe"
	|	"synchronized"
//	|	"const"			// reserved word, but not valid
	|	"volatile"
	|	"strictfp"
	;

// inherited from grammar GeneratedJavaRecognizer
classDefinition![MyCommonAST modifiers, MyModifierSet modSet] :cc:"class" IDENT
		// it _might_ have a superclass...
		sc:superClassClause
		// it might implement some interfaces...
		ic:implementsClause
		// now parse the body of the class
        {
            ver.verifyType(modSet, #IDENT);
            ver.reportStartTypeBlock(modSet.getVisibilityScope(), false);
        }
		cb:classBlock[(modSet.size() == 0) ? #cc.getLineNo() : modSet.getFirstLineNo()]
		{#classDefinition = #(#[CLASS_DEF,"CLASS_DEF"],
							   modifiers,IDENT,sc,ic,cb);}
        {
            ver.reportEndTypeBlock();
        }
	;

// inherited from grammar GeneratedJavaRecognizer
superClassClause! :( "extends" id:identifier )?
		{#superClassClause = #(#[EXTENDS_CLAUSE,"EXTENDS_CLAUSE"],id);}
	;

// inherited from grammar GeneratedJavaRecognizer
interfaceDefinition![MyCommonAST modifiers, MyModifierSet modSet] :ii:"interface" IDENT
		// it might extend some other interfaces
		ie:interfaceExtends
		// now parse the body of the interface (looks like a class...)
        {
            ver.verifyType(modSet, #IDENT);
            ver.reportStartTypeBlock(modSet.getVisibilityScope(), true);
        }
		cb:classBlock[(modSet.size() == 0) ? #ii.getLineNo() : modSet.getFirstLineNo()]
		{#interfaceDefinition = #(#[INTERFACE_DEF,"INTERFACE_DEF"],
									modifiers,IDENT,ie,cb);}
        {
            ver.reportEndTypeBlock();
        }
	;

// inherited from grammar GeneratedJavaRecognizer
classBlock[int aLine] :lc:LCURLY! { if (aLine != -1) ver.verifyLCurlyType(aLine, #lc); }
			( field | SEMI! )*
		RCURLY!
		{#classBlock = #([OBJBLOCK, "OBJBLOCK"], #classBlock);}
	;

// inherited from grammar GeneratedJavaRecognizer
interfaceExtends :(
		e:"extends"!
		identifier ( COMMA! identifier )*
		)?
		{#interfaceExtends = #(#[EXTENDS_CLAUSE,"EXTENDS_CLAUSE"],
							#interfaceExtends);}
	;

// inherited from grammar GeneratedJavaRecognizer
implementsClause :(
			i:"implements"! identifier ( COMMA! identifier )*
		)?
		{#implementsClause = #(#[IMPLEMENTS_CLAUSE,"IMPLEMENTS_CLAUSE"],
								 #implementsClause);}
	;

// inherited from grammar GeneratedJavaRecognizer
field! {
    java.util.List exs = new java.util.ArrayList();
    MethodSignature msig = new MethodSignature();
    final MyCommonAST[] stmtBraces = new MyCommonAST[2];
}
:// method, constructor, or variable declaration
		mods:modifiers[msig.getModSet()]
		(	h:ctorHead[exs, msig]
            {
                msig.setThrows(exs);
                ver.verifyMethod(msig);
                ver.reportStartMethodBlock();
            }
            s:constructorBody[msig.getFirstLineNo()] // constructor
			{#field = #(#[CTOR_DEF,"CTOR_DEF"], mods, h, s);}
            {ver.reportEndMethodBlock();}

		|	cd:classDefinition[#mods, msig.getModSet()]       // inner class
			{#field = #cd;}

		|	id:interfaceDefinition[#mods, msig.getModSet()]   // inner interface
			{#field = #id;}

		|	t:typeSpec[false]  // method or variable declaration(s)
			(	IDENT  // the name of the method

				// parse the formal parameter declarations.
				LPAREN! param:parameterDeclarationList[msig] RPAREN!

				rt:declaratorBrackets[#t]

				// get the list of exceptions that this method is
				// declared to throw
				(tc:throwsClause[exs])?

                {
                    msig.setName(#IDENT);
                    msig.setThrows(exs);
                    msig.setReturnType(#t);
                    ver.verifyMethod(msig);
                    ver.reportStartMethodBlock();
                }
				(
                    s2:compoundStatement[stmtBraces]
                    {
                        ver.verifyLCurlyMethod(msig.getFirstLineNo(), stmtBraces[0]);
                        ver.verifyMethodLength(
                            #s2.getLineNo(),
                            stmtBraces[1].getLineNo()
                            - stmtBraces[0].getLineNo() + 1);
                    }
                |
                    SEMI
                )
				{#field = #(#[METHOD_DEF,"METHOD_DEF"],
						     mods,
							 #(#[TYPE,"TYPE"],rt),
							 IDENT,
							 param,
							 tc,
							 s2); }
                {ver.reportEndMethodBlock();}
			|	v:variableDefinitions[#mods,#t, msig.getModSet()] SEMI
				{#field = #v;}
			)
		)

    // "static { ... }" class initializer
	|	st:"static" {ver.reportStartMethodBlock();} s3:compoundStatement[stmtBraces]
        {
            #field = #(#[STATIC_INIT,"STATIC_INIT"], s3);
            ver.reportEndMethodBlock();
            ver.verifyLCurlyOther(st.getLine(), stmtBraces[0]);
        }

    // "{ ... }" instance initializer
	|	{ver.reportStartMethodBlock();} s4:compoundStatement[sIgnoreAST] {ver.reportEndMethodBlock();}
		{#field = #(#[INSTANCE_INIT,"INSTANCE_INIT"], s4);}
	;

// inherited from grammar GeneratedJavaRecognizer
constructorBody[int aLineNo] :lc:LCURLY^ {#lc.setType(SLIST); ver.verifyLCurlyMethod(aLineNo, #lc); }
		// Predicate might be slow but only checked once per constructor def
		// not for general methods.
		(	(explicitConstructorInvocation) => explicitConstructorInvocation
		|
		)
        (statement[sIgnoreType, sIgnoreAST])*
        rc:RCURLY! {ver.verifyConstructorLength(#lc.getLineNo(), #rc.getLineNo() - #lc.getLineNo() + 1);}
    ;

// inherited from grammar GeneratedJavaRecognizer
explicitConstructorInvocation :(	options {
				// this/super can begin a primaryExpression too; with finite
				// lookahead ANTLR will think the 3rd alternative conflicts
				// with 1, 2.  I am shutting off warning since ANTLR resolves
				// the nondeterminism by correctly matching alts 1 or 2 when
				// it sees this( or super(
				generateAmbigWarnings=false;
			}
		:	"this"! lp1:LPAREN^ argList RPAREN! SEMI!
			{#lp1.setType(CTOR_CALL);}

	    |   "super"! lp2:LPAREN^ argList RPAREN! SEMI!
			{#lp2.setType(SUPER_CTOR_CALL);}

			// (new Outer()).super()  (create enclosing instance)
		|	primaryExpression DOT! {ver.verifyDot(#DOT);} "super"! lp3:LPAREN^ argList RPAREN! SEMI!
			{#lp3.setType(SUPER_CTOR_CALL);}
		)
    ;

// inherited from grammar GeneratedJavaRecognizer
variableDefinitions[MyCommonAST mods, MyCommonAST t, MyModifierSet modSet] :variableDeclarator[(MyCommonAST) getASTFactory().dupTree(mods),
						   (MyCommonAST) getASTFactory().dupTree(t),
                           modSet]
		(	COMMA!
			variableDeclarator[(MyCommonAST) getASTFactory().dupTree(mods),
							   (MyCommonAST) getASTFactory().dupTree(t),
                               modSet]
		)*
	;

// inherited from grammar GeneratedJavaRecognizer
variableDeclarator![MyCommonAST mods, MyCommonAST t, MyModifierSet modSet] :id:IDENT d:declaratorBrackets[t] v:varInitializer
		{#variableDeclarator = #(#[VARIABLE_DEF,"VARIABLE_DEF"], mods, #(#[TYPE,"TYPE"],d), id, v);}
        {
            ver.verifyVariable(new MyVariable(new LineText(id.getLine(), id.getColumn(), id.getText()), modSet));
        }
	;

// inherited from grammar GeneratedJavaRecognizer
declaratorBrackets[MyCommonAST typ] :{#declaratorBrackets=typ;}
		(lb:LBRACK^ {#lb.setType(ARRAY_DECLARATOR);} RBRACK!)*
	;

// inherited from grammar GeneratedJavaRecognizer
varInitializer :( ASSIGN^ initializer )?
	;

// inherited from grammar GeneratedJavaRecognizer
arrayInitializer :lc:LCURLY^ {#lc.setType(ARRAY_INIT);}
			(	initializer
				(
					// CONFLICT: does a COMMA after an initializer start a new
					//           initializer or start the option ',' at end?
					//           ANTLR generates proper code by matching
					//			 the comma as soon as possible.
					options {
						warnWhenFollowAmbig = false;
					}
				:
					COMMA! initializer
				)*
				(COMMA!)?
			)?
		RCURLY!
	;

// inherited from grammar GeneratedJavaRecognizer
initializer :expression
	|	arrayInitializer
	;

// inherited from grammar GeneratedJavaRecognizer
ctorHead[java.util.List exs, MethodSignature msig] :IDENT  { msig.setName(#IDENT); } // the name of the method

		// parse the formal parameter declarations.
		LPAREN! parameterDeclarationList[msig] RPAREN!

		// get the list of exceptions that this method is declared to throw
		(throwsClause[exs])?
	;

// inherited from grammar GeneratedJavaRecognizer
throwsClause[java.util.List exs] :"throws"^ i1:identifier { exs.add(sLastIdentifier); }
        ( COMMA! i2:identifier { exs.add(sLastIdentifier); } )*
	;

// inherited from grammar GeneratedJavaRecognizer
parameterDeclarationList[MethodSignature msig] :( parameterDeclaration[msig] ( COMMA! parameterDeclaration[msig] )* )?
		{#parameterDeclarationList = #(#[PARAMETERS,"PARAMETERS"],
									#parameterDeclarationList);}
	;

// inherited from grammar GeneratedJavaRecognizer
parameterDeclaration![MethodSignature msig] :pm:parameterModifier t:typeSpec[false] id:IDENT
		pd:declaratorBrackets[#t]
		{#parameterDeclaration = #(#[PARAMETER_DEF,"PARAMETER_DEF"],
									pm, #([TYPE,"TYPE"],pd), id);}
        {
            msig.addParam(new LineText(#id.getLineNo(), #id.getColumnNo(), #id.getText()));
        }
	;

// inherited from grammar GeneratedJavaRecognizer
parameterModifier :(f:"final")?
		{#parameterModifier = #(#[MODIFIERS,"MODIFIERS"], f);}
	;

// inherited from grammar GeneratedJavaRecognizer
compoundStatement[MyCommonAST[] aCurlies] :lc:LCURLY^  {#lc.setType(SLIST); aCurlies[0] = #lc;}
			// include the (possibly-empty) list of statements
			(statement[sIgnoreType, sIgnoreAST])*
		rc:RCURLY!  { aCurlies[1] = #rc; }
	;

// inherited from grammar GeneratedJavaRecognizer
traditionalStatement[int[] aType, MyCommonAST[] aCurlies] {
    final MyModifierSet modSet = new MyModifierSet();
    final int[] stmtType = new int[1];
    final MyCommonAST[] stmtBraces = new MyCommonAST[2];
    stmtType[0] = STMT_OTHER;
}
:compoundStatement[aCurlies] { aType[0] = STMT_COMPOUND; }

	// declarations are ambiguous with "ID DOT" relative to expression
	// statements.  Must backtrack to be sure.  Could use a semantic
	// predicate to test symbol table to see what the type was coming
	// up, but that's pretty hard without a symbol table ;)
	|	(declaration)=> declaration SEMI!

	// An expression statement.  This could be a method call,
	// assignment statement, or any other expression evaluated for
	// side-effects.
	|	expression SEMI!

	// class definition
	|	m:modifiers[modSet]! classDefinition[#m, modSet]

	// Attach a label to the front of a statement
	|	IDENT c:COLON^ {#c.setType(LABELED_STAT);} statement[sIgnoreType, sIgnoreAST]

    // If-else statement
	|	ii:"if"^ LPAREN! expression RPAREN! statement[stmtType, stmtBraces]
        {
            aType[0] = STMT_IF;
            ver.verifyWSAroundBegin(ii.getLine(), ii.getColumn(), ii.getText());
            if (stmtType[0] != STMT_COMPOUND) {
                ver.reportNeedBraces(ii);
            }
            else {
                ver.verifyLCurlyOther(ii.getLine(), stmtBraces[0]);
            }
        }
		(
			// CONFLICT: the old "dangling-else" problem...
			//           ANTLR generates proper code matching
			//			 as soon as possible.  Hush warning.
			options {
				warnWhenFollowAmbig = false;
			}
		:
			ee:"else"!
            {
                if (stmtType[0] == STMT_COMPOUND) {
                    ver.verifyRCurly(stmtBraces[1], ee.getLine());
                }
                stmtType[0] = STMT_OTHER;
            }
            statement[stmtType, stmtBraces]
            {
                ver.verifyWSAroundBegin(ee.getLine(), ee.getColumn(), ee.getText());
                if (stmtType[0] == STMT_OTHER) {
                    ver.reportNeedBraces(ee);
                }
                else if (stmtType[0] == STMT_COMPOUND) {
                    ver.verifyLCurlyOther(ee.getLine(), stmtBraces[0]);
                }
            }
		)?

	// For statement
	|	ff:"for"^
        LPAREN!
        forInit s1:SEMI! // initializer
        forCond	s2:SEMI! // condition test
        forIter         // updater
        RPAREN!
        statement[stmtType, stmtBraces] // statement to loop over
        {
            ver.verifyWSAroundBegin(ff.getLine(), ff.getColumn(), ff.getText());
            ver.verifyWSAfter(s1.getLine(), s1.getColumn(), MyToken.SEMI_COLON);
            ver.verifyWSAfter(s2.getLine(), s2.getColumn(), MyToken.SEMI_COLON, ")");
            if (stmtType[0] != STMT_COMPOUND) {
                ver.reportNeedBraces(ff);
            }
            else {
                ver.verifyLCurlyOther(ff.getLine(), stmtBraces[0]);
            }
        }

	// While statement
	|	ww:"while"^ LPAREN! expression RPAREN! statement[stmtType, stmtBraces]
        {
            ver.verifyWSAroundBegin(ww.getLine(), ww.getColumn(), ww.getText());
            if (stmtType[0] != STMT_COMPOUND) {
                ver.reportNeedBraces(ww);
            }
            else {
                ver.verifyLCurlyOther(ww.getLine(), stmtBraces[0]);
            }
        }

	// do-while statement
	|	dd:"do"^ statement[stmtType, stmtBraces] dw:"while"! LPAREN! expression RPAREN! SEMI!
        {
            ver.verifyWSAroundBegin(dd.getLine(), dd.getColumn(), dd.getText());
            ver.verifyWSAroundBegin(dw.getLine(), dw.getColumn(), dw.getText());
            if (stmtType[0] != STMT_COMPOUND) {
                ver.reportNeedBraces(dd);
            }
            else {
                ver.verifyLCurlyOther(dd.getLine(), stmtBraces[0]);
            }
        }

	// get out of a loop (or switch)
	|	"break"^ (IDENT)? SEMI!

	// do next iteration of a loop
	|	"continue"^ (IDENT)? SEMI!

	// Return an expression
	|	rr:"return"^ (expression {ver.verifyWSAroundBegin(rr.getLine(), rr.getColumn(), rr.getText());} )? SEMI!

	// switch/case statement
	|	ss2:"switch"^ LPAREN! expression RPAREN! lc:LCURLY!
        { ver.verifyLCurlyOther(ss2.getLine(), #lc); }
			( casesGroup )*
		RCURLY!

	// exception try-catch block
	|	tryBlock

	// throw an exception
	|	"throw"^ expression SEMI!

	// synchronize a statement
	|	ss:"synchronized"^ LPAREN! expression RPAREN! compoundStatement[stmtBraces]
        {
            ver.verifyWSAroundBegin(ss.getLine(), ss.getColumn(), ss.getText());
            ver.verifyLCurlyOther(ss.getLine(), stmtBraces[0]);
        }

	// empty statement
	|	s:SEMI {#s.setType(EMPTY_STAT);}
	;

// inherited from grammar GeneratedJavaRecognizer
casesGroup :(	// CONFLICT: to which case group do the statements bind?
			//           ANTLR generates proper code: it groups the
			//           many "case"/"default" labels together then
			//           follows them with the statements
			options {
				warnWhenFollowAmbig = false;
			}
			:
			aCase
		)+
		caseSList
		{#casesGroup = #([CASE_GROUP, "CASE_GROUP"], #casesGroup);}
	;

// inherited from grammar GeneratedJavaRecognizer
aCase :("case"^ expression | "default") COLON!
	;

// inherited from grammar GeneratedJavaRecognizer
caseSList :(statement[sIgnoreType, sIgnoreAST])*
		{#caseSList = #(#[SLIST,"SLIST"],#caseSList);}
	;

// inherited from grammar GeneratedJavaRecognizer
forInit :(	(declaration)=> declaration
		// otherwise it could be an expression list...
		|	expressionList
		)?
		{#forInit = #(#[FOR_INIT,"FOR_INIT"],#forInit);}
	;

// inherited from grammar GeneratedJavaRecognizer
forCond :(expression)?
		{#forCond = #(#[FOR_CONDITION,"FOR_CONDITION"],#forCond);}
	;

// inherited from grammar GeneratedJavaRecognizer
forIter :(expressionList)?
		{#forIter = #(#[FOR_ITERATOR,"FOR_ITERATOR"],#forIter);}
	;

// inherited from grammar GeneratedJavaRecognizer
tryBlock {
    final MyCommonAST[] stmtBraces = new MyCommonAST[2];
    final MethodSignature ignoreMS = new MethodSignature();
}
:t:"try"^ compoundStatement[stmtBraces]
        {
            ver.verifyWSAroundBegin(t.getLine(), t.getColumn(), t.getText());
            ver.verifyLCurlyOther(t.getLine(), stmtBraces[0]);
        }

        (
            c:"catch"^ { ver.verifyRCurly(stmtBraces[1], c.getLine()); }
            LPAREN! parameterDeclaration[ignoreMS] RPAREN! compoundStatement[stmtBraces]
            {
                ver.verifyWSAroundBegin(
                    c.getLine(), c.getColumn(), c.getText());
                ver.verifyLCurlyOther(c.getLine(), stmtBraces[0]);
            }
        )*

        (
            f:"finally"^ { ver.verifyRCurly(stmtBraces[1], f.getLine()); }
            compoundStatement[stmtBraces]
            { ver.verifyLCurlyOther(f.getLine(), stmtBraces[0]); }
        )?
	;

// inherited from grammar GeneratedJavaRecognizer
expression :assignmentExpression
		{#expression = #(#[EXPR,"EXPR"],#expression);}
	;

// inherited from grammar GeneratedJavaRecognizer
expressionList :expression (COMMA! expression)*
		{#expressionList = #(#[ELIST,"ELIST"], expressionList);}
	;

// inherited from grammar GeneratedJavaRecognizer
assignmentExpression :conditionalExpression
		(	(	ASSIGN^
            |   PLUS_ASSIGN^
            |   MINUS_ASSIGN^
            |   STAR_ASSIGN^
            |   DIV_ASSIGN^
            |   MOD_ASSIGN^
            |   SR_ASSIGN^
            |   BSR_ASSIGN^
            |   SL_ASSIGN^
            |   BAND_ASSIGN^
            |   BXOR_ASSIGN^
            |   BOR_ASSIGN^
            )
			assignmentExpression
		)?
	;

// inherited from grammar GeneratedJavaRecognizer
conditionalExpression :logicalOrExpression
		( QUESTION^ assignmentExpression c:COLON {ver.verifyWSAroundBegin(c.getLine(), c.getColumn(), c.getText());} conditionalExpression )?
	;

// inherited from grammar GeneratedJavaRecognizer
logicalOrExpression :logicalAndExpression (LOR^ logicalAndExpression)*
	;

// inherited from grammar GeneratedJavaRecognizer
logicalAndExpression :inclusiveOrExpression (LAND^ inclusiveOrExpression)*
	;

// inherited from grammar GeneratedJavaRecognizer
inclusiveOrExpression :exclusiveOrExpression (BOR^ exclusiveOrExpression)*
	;

// inherited from grammar GeneratedJavaRecognizer
exclusiveOrExpression :andExpression (BXOR^ andExpression)*
	;

// inherited from grammar GeneratedJavaRecognizer
andExpression :equalityExpression (BAND^ equalityExpression)*
	;

// inherited from grammar GeneratedJavaRecognizer
equalityExpression :relationalExpression ((NOT_EQUAL^ | EQUAL^) relationalExpression)*
	;

// inherited from grammar GeneratedJavaRecognizer
relationalExpression :shiftExpression
		(	(	(	LT^
				|	GT^
				|	LE^
				|	GE^
				)
				shiftExpression
			)*
		|	"instanceof"^ typeSpec[true]
		)
	;

// inherited from grammar GeneratedJavaRecognizer
shiftExpression :additiveExpression ((SL^ | SR^ | BSR^) additiveExpression)*
	;

// inherited from grammar GeneratedJavaRecognizer
additiveExpression :multiplicativeExpression
        ((p:PLUS^ {ver.verifyWSAroundBegin(p.getLine(), p.getColumn(), p.getText());}| m:MINUS^ {ver.verifyWSAroundBegin(m.getLine(), m.getColumn(), m.getText());} )
            multiplicativeExpression)*
	;

// inherited from grammar GeneratedJavaRecognizer
multiplicativeExpression :unaryExpression ((s:STAR^ {ver.verifyWSAroundBegin(s.getLine(), s.getColumn(), s.getText());} | DIV^ | MOD^ )  unaryExpression)*
	;

// inherited from grammar GeneratedJavaRecognizer
unaryExpression :INC^ unaryExpression {ver.verifyNoWSAfter(#INC);}
	|	DEC^ unaryExpression {ver.verifyNoWSAfter(#DEC);}
	|	MINUS^ {#MINUS.setType(UNARY_MINUS); ver.verifyNoWSAfter(#MINUS);} unaryExpression
	|	PLUS^  {#PLUS.setType(UNARY_PLUS); ver.verifyNoWSAfter(#PLUS);} unaryExpression
	|	unaryExpressionNotPlusMinus
	;

// inherited from grammar GeneratedJavaRecognizer
unaryExpressionNotPlusMinus :BNOT^ unaryExpression {ver.verifyNoWSAfter(#BNOT);}
	|	LNOT^ unaryExpression {ver.verifyNoWSAfter(#LNOT);}

	|	(	// subrule allows option to shut off warnings
			options {
				// "(int" ambig with postfixExpr due to lack of sequence
				// info in linear approximate LL(k).  It's ok.  Shut up.
				generateAmbigWarnings=false;
			}
		:	// If typecast is built in type, must be numeric operand
			// Also, no reason to backtrack if type keyword like int, float...
			lpb:LPAREN^ {#lpb.setType(TYPECAST);} builtInTypeSpec[true] rpb:RPAREN! {ver.verifyWSAfter(rpb.getLine(), rpb.getColumn(), MyToken.CAST);}
			unaryExpression

			// Have to backtrack to see if operator follows.  If no operator
			// follows, it's a typecast.  No semantic checking needed to parse.
			// if it _looks_ like a cast, it _is_ a cast; else it's a "(expr)"
		|	(LPAREN classTypeSpec[true] RPAREN unaryExpressionNotPlusMinus)=>
			lp:LPAREN^ {#lp.setType(TYPECAST);} classTypeSpec[true] rpb2:RPAREN! {ver.verifyWSAfter(rpb2.getLine(), rpb2.getColumn(), MyToken.CAST);}
			unaryExpressionNotPlusMinus

		|	postfixExpression
		)
	;

// inherited from grammar GeneratedJavaRecognizer
postfixExpression :primaryExpression // start with a primary

		(	// qualified id (id.id.id.id...) -- build the name
			DOT^ {ver.verifyDot(#DOT);} ( IDENT {ver.reportReference(sFirstIdent);}
				| "this"
				| "class" {ver.reportReference(sFirstIdent);}
				| newExpression
				| "super" // ClassName.super.field
				)
			// the above line needs a semantic check to make sure "class"
			// is the _last_ qualifier.

			// allow ClassName[].class
		|	( lbc:LBRACK^ {#lbc.setType(ARRAY_DECLARATOR);} RBRACK! )+
			DOT^ "class" {ver.verifyDot(#DOT);}

			// an array indexing operation
		|	lb:LBRACK^ {#lb.setType(INDEX_OP);} expression RBRACK!

			// method invocation
			// The next line is not strictly proper; it allows x(3)(4) or
			//  x[2](4) which are not valid in Java.  If this grammar were used
			//  to validate a Java program a semantic check would be needed, or
			//   this rule would get really ugly...
			// It also allows ctor invocation like super(3) which is now
			// handled by the explicit constructor rule, but it would
			// be hard to syntactically prevent ctor calls here
		|	lp:LPAREN^ {#lp.setType(METHOD_CALL);}
				argList
			RPAREN!
		)*

		// possibly add on a post-increment or post-decrement.
		// allows INC/DEC on too much, but semantics can check
		(	in:INC^ {#in.setType(POST_INC); ver.verifyNoWSBefore(#in);}
	 	|	de:DEC^ {#de.setType(POST_DEC); ver.verifyNoWSBefore(#de);}
		|	// nothing
		)
	;

// inherited from grammar GeneratedJavaRecognizer
primaryExpression :i1:IDENT {sFirstIdent = i1.getText();}
	|	constant
	|	"true"
	|	"false"
	|	"this"
	|	"null"
	|	newExpression
	|	LPAREN! assignmentExpression RPAREN!
	|	"super"
		// look for int.class and int[].class
	|	builtInType
		( lbt:LBRACK^ {#lbt.setType(ARRAY_DECLARATOR);} RBRACK! )*
		DOT^ "class" { ver.verifyDot(#DOT); }
	;

// inherited from grammar GeneratedJavaRecognizer
newExpression :"new"^ type
		(	LPAREN! argList RPAREN! ({ver.reportStartTypeBlock(Scope.ANONINNER, false);}  classBlock[-1]  {ver.reportEndTypeBlock();})?

			//java 1.1
			// Note: This will allow bad constructs like
			//    new int[4][][3] {exp,exp}.
			//    There needs to be a semantic check here...
			// to make sure:
			//   a) [ expr ] and [ ] are not mixed
			//   b) [ expr ] and an init are not used together

		|	newArrayDeclarator (arrayInitializer)?
		)
	;

// inherited from grammar GeneratedJavaRecognizer
argList :(	expressionList
		|	/*nothing*/
			{#argList = #[ELIST,"ELIST"];}
		)
	;

// inherited from grammar GeneratedJavaRecognizer
newArrayDeclarator :(
			// CONFLICT:
			// newExpression is a primaryExpression which can be
			// followed by an array index reference.  This is ok,
			// as the generated code will stay in this loop as
			// long as it sees an LBRACK (proper behavior)
			options {
				warnWhenFollowAmbig = false;
			}
		:
			lb:LBRACK^ {#lb.setType(ARRAY_DECLARATOR);}
				(expression)?
			RBRACK!
		)+
	;

// inherited from grammar GeneratedJavaRecognizer
constant :NUM_INT
	|	CHAR_LITERAL
	|	STRING_LITERAL
	|	NUM_FLOAT
	|	NUM_LONG
	|	NUM_DOUBLE
	;

class GeneratedJava14Lexer extends Lexer;

options {
	exportVocab=GeneratedJava14;
	testLiterals=false;
	k=4;
	charVocabulary='\u0003'..'\uFFFF';
	codeGenBitsetTestThreshold=20;
	importVocab=GeneratedJava;
}

tokens {
        ASSERT="assert";
}
{
    final Verifier ver = VerifierSingleton.getInstance();

    // explicitly set tab width to 1 (default in ANTLR 2.7.1)
    // in ANTLR 2.7.2a2 the default has changed from 1 to 8
    public void tab()
    {
        setColumn( getColumn() + 1 );
    }
}
protected FLOAT_SUFFIX :'f'|'F'|'d'|'D'
	;

// inherited from grammar GeneratedJavaLexer
QUESTION :'?' {ver.verifyWSAroundEnd(getLine(), getColumn(), "?");} ;

// inherited from grammar GeneratedJavaLexer
LPAREN :'(' { ver.verifyLParen(getLine(), getColumn()); } ;

// inherited from grammar GeneratedJavaLexer
RPAREN :')' { ver.verifyRParen(getLine(), getColumn()); } ;

// inherited from grammar GeneratedJavaLexer
LBRACK :'['  ;

// inherited from grammar GeneratedJavaLexer
RBRACK :']'  ;

// inherited from grammar GeneratedJavaLexer
LCURLY :'{'  ;

// inherited from grammar GeneratedJavaLexer
RCURLY :'}'  ;

// inherited from grammar GeneratedJavaLexer
COLON :':' ;

// inherited from grammar GeneratedJavaLexer
COMMA :',' {ver.verifyWSAfter(getLine(), getColumn() - 1, MyToken.COMMA);} ;

// inherited from grammar GeneratedJavaLexer
ASSIGN :'=' {ver.verifyWSAroundEnd(getLine(), getColumn(), "=");} ;

// inherited from grammar GeneratedJavaLexer
EQUAL :"==" {ver.verifyWSAroundEnd(getLine(), getColumn(), "==");} ;

// inherited from grammar GeneratedJavaLexer
LNOT :'!' ;

// inherited from grammar GeneratedJavaLexer
BNOT :'~' ;

// inherited from grammar GeneratedJavaLexer
NOT_EQUAL :"!=" {ver.verifyWSAroundEnd(getLine(), getColumn(), "!=");};

// inherited from grammar GeneratedJavaLexer
DIV :'/' {ver.verifyWSAroundEnd(getLine(), getColumn(), "/");} ;

// inherited from grammar GeneratedJavaLexer
DIV_ASSIGN :"/=" {ver.verifyWSAroundEnd(getLine(), getColumn(), "/=");};

// inherited from grammar GeneratedJavaLexer
PLUS :'+';

// inherited from grammar GeneratedJavaLexer
PLUS_ASSIGN :"+=" {ver.verifyWSAroundEnd(getLine(), getColumn(), "+=");};

// inherited from grammar GeneratedJavaLexer
INC :"++" ;

// inherited from grammar GeneratedJavaLexer
MINUS :'-' ;

// inherited from grammar GeneratedJavaLexer
MINUS_ASSIGN :"-=" {ver.verifyWSAroundEnd(getLine(), getColumn(), "-=");};

// inherited from grammar GeneratedJavaLexer
DEC :"--" ;

// inherited from grammar GeneratedJavaLexer
STAR :'*' ;

// inherited from grammar GeneratedJavaLexer
STAR_ASSIGN :"*=" {ver.verifyWSAroundEnd(getLine(), getColumn(), "*=");};

// inherited from grammar GeneratedJavaLexer
MOD :'%' {ver.verifyWSAroundEnd(getLine(), getColumn(), "%");} ;

// inherited from grammar GeneratedJavaLexer
MOD_ASSIGN :"%=" {ver.verifyWSAroundEnd(getLine(), getColumn(), "%=");};

// inherited from grammar GeneratedJavaLexer
SR :">>" {ver.verifyWSAroundEnd(getLine(), getColumn(), ">>");};

// inherited from grammar GeneratedJavaLexer
SR_ASSIGN :">>=" {ver.verifyWSAroundEnd(getLine(), getColumn(), ">>=");};

// inherited from grammar GeneratedJavaLexer
BSR :">>>" {ver.verifyWSAroundEnd(getLine(), getColumn(), ">>>");};

// inherited from grammar GeneratedJavaLexer
BSR_ASSIGN :">>>=" {ver.verifyWSAroundEnd(getLine(), getColumn(), ">>>=");};

// inherited from grammar GeneratedJavaLexer
GE :">=" {ver.verifyWSAroundEnd(getLine(), getColumn(), ">=");};

// inherited from grammar GeneratedJavaLexer
GT :">" {ver.verifyWSAroundEnd(getLine(), getColumn(), ">");};

// inherited from grammar GeneratedJavaLexer
SL :"<<" {ver.verifyWSAroundEnd(getLine(), getColumn(), "<<");};

// inherited from grammar GeneratedJavaLexer
SL_ASSIGN :"<<=" {ver.verifyWSAroundEnd(getLine(), getColumn(), "<<=");};

// inherited from grammar GeneratedJavaLexer
LE :"<=" {ver.verifyWSAroundEnd(getLine(), getColumn(), "<=");};

// inherited from grammar GeneratedJavaLexer
LT :'<' {ver.verifyWSAroundEnd(getLine(), getColumn(), "<");};

// inherited from grammar GeneratedJavaLexer
BXOR :'^' {ver.verifyWSAroundEnd(getLine(), getColumn(), "^");};

// inherited from grammar GeneratedJavaLexer
BXOR_ASSIGN :"^=" {ver.verifyWSAroundEnd(getLine(), getColumn(), "^=");};

// inherited from grammar GeneratedJavaLexer
BOR :'|' {ver.verifyWSAroundEnd(getLine(), getColumn(), "|" );};

// inherited from grammar GeneratedJavaLexer
BOR_ASSIGN :"|=" {ver.verifyWSAroundEnd(getLine(), getColumn(), "|=");};

// inherited from grammar GeneratedJavaLexer
LOR :"||" {ver.verifyWSAroundEnd(getLine(), getColumn(), "||");};

// inherited from grammar GeneratedJavaLexer
BAND :'&' {ver.verifyWSAroundEnd(getLine(), getColumn(), "&");};

// inherited from grammar GeneratedJavaLexer
BAND_ASSIGN :"&=" {ver.verifyWSAroundEnd(getLine(), getColumn(), "&=");};

// inherited from grammar GeneratedJavaLexer
LAND :"&&" {ver.verifyWSAroundEnd(getLine(), getColumn(), "&&");};

// inherited from grammar GeneratedJavaLexer
SEMI :';'  ;

// inherited from grammar GeneratedJavaLexer
WS :(	' '
		|	'\t'
		|	'\f'
			// handle newlines
		|	(	options {generateAmbigWarnings=false;}
			:	"\r\n"  // Evil DOS
			|	'\r'    // Macintosh
			|	'\n'    // Unix (the right way)
			)
			{ newline(); }
		)+
		{ _ttype = Token.SKIP; }
	;

// inherited from grammar GeneratedJavaLexer
SL_COMMENT :"//"
      (~('\n'|'\r'))* ('\n'|'\r'('\n')?)
      {
         $setType(Token.SKIP);
         newline();
      }
   ;

// inherited from grammar GeneratedJavaLexer
ML_COMMENT {
   int startLine;
   int startCol;
}
:"/*"  { startLine = getLine(); startCol = getColumn() - 3; }
      (/* '\r' '\n' can be matched in one alternative or by matching
          '\r' in one iteration and '\n' in another.  I am trying to
          handle any flavor of newline that comes in, but the language
          that allows both "\r\n" and "\r" and "\n" to all be valid
          newline is ambiguous.  Consequently, the resulting grammar
          must be ambiguous.  I'm shutting this warning off.
       */
       options {
          generateAmbigWarnings=false;
       }
       :
          { LA(2)!='/' }? '*'
          | '\r' '\n'  {newline();}
          | '\r'       {newline();}
          | '\n'       {newline();}
          | ~('*'|'\n'|'\r')
      )*
      "*/"
      {
         ver.reportCComment(startLine, startCol,
                            getLine(), getColumn() - 2);
         $setType(Token.SKIP);
      }
   ;

// inherited from grammar GeneratedJavaLexer
CHAR_LITERAL :'\'' ( ESC | ~'\'' ) '\''
	;

// inherited from grammar GeneratedJavaLexer
STRING_LITERAL :'"' (ESC|~('"'|'\\'))* '"'
	;

// inherited from grammar GeneratedJavaLexer
protected ESC :'\\'
		(	'n'
		|	'r'
		|	't'
		|	'b'
		|	'f'
		|	'"'
		|	'\''
		|	'\\'
		|	('u')+ HEX_DIGIT HEX_DIGIT HEX_DIGIT HEX_DIGIT
		|	('0'..'3')
			(
				options {
					warnWhenFollowAmbig = false;
				}
			:	('0'..'7')
				(
					options {
						warnWhenFollowAmbig = false;
					}
				:	'0'..'7'
				)?
			)?
		|	('4'..'7')
			(
				options {
					warnWhenFollowAmbig = false;
				}
			:	('0'..'9')
			)?
		)
	;

// inherited from grammar GeneratedJavaLexer
protected HEX_DIGIT :('0'..'9'|'A'..'F'|'a'..'f')
	;

// inherited from grammar GeneratedJavaLexer
protected VOCAB :'\3'..'\377'
	;

// inherited from grammar GeneratedJavaLexer
IDENT 
options {
	testLiterals=true;
}
:('a'..'z'|'A'..'Z'|'_'|'$') ('a'..'z'|'A'..'Z'|'_'|'0'..'9'|'$')*
	;

// inherited from grammar GeneratedJavaLexer
NUM_INT {boolean isDecimal=false; Token t=null;}
:'.' {_ttype = DOT;}
            (	('0'..'9')+ (EXPONENT)? (f1:FLOAT_SUFFIX {t=f1;})?
                {
				if (t != null && t.getText().toUpperCase().indexOf('D')>=0) {
                	_ttype = NUM_DOUBLE;
				}
				else {
                	_ttype = NUM_FLOAT;
				}
				}
            )?

	|	(	'0' {isDecimal = true;} // special case for just '0'
			(	('x'|'X')
				(											// hex
					// the 'e'|'E' and float suffix stuff look
					// like hex digits, hence the (...)+ doesn't
					// know when to stop: ambig.  ANTLR resolves
					// it correctly by matching immediately.  It
					// is therefor ok to hush warning.
					options {
						warnWhenFollowAmbig=false;
					}
				:	HEX_DIGIT
				)+
			|	('0'..'7')+									// octal
			)?
		|	('1'..'9') ('0'..'9')*  {isDecimal=true;}		// non-zero decimal
		)
		(	('l'|'L') { _ttype = NUM_LONG; }

		// only check to see if it's a float if looks like decimal so far
		|	{isDecimal}?
            (   '.' ('0'..'9')* (EXPONENT)? (f2:FLOAT_SUFFIX {t=f2;})?
            |   EXPONENT (f3:FLOAT_SUFFIX {t=f3;})?
            |   f4:FLOAT_SUFFIX {t=f4;}
            )
            {
			if (t != null && t.getText().toUpperCase() .indexOf('D') >= 0) {
                _ttype = NUM_DOUBLE;
			}
            else {
                _ttype = NUM_FLOAT;
			}
			}
        )?
	;

// inherited from grammar GeneratedJavaLexer
protected EXPONENT :('e'|'E') ('+'|'-')? ('0'..'9')+
	;


